package com.jdcloud.media.demo;


import android.app.Application;
import android.os.Environment;

import com.jdcloud.media.demo.common.Constant;
import com.jd.sentry.Sentry;
import com.jdcloud.media.demo.common.network.OkHttpUtil;
import com.jdcloud.media.demo.utils.LogUtil;
import com.jdcloud.media.live.LiveSDK;
//import com.jdcloud.media.player.wrapper.JDCloudVideoCache;
//import com.jdcloud.media.player.wrapper.JDCloudVideoCache;
import com.jdcloud.media.player.wrapper.JDCloudVideoCache;
import com.jingdong.sdk.jdcrashreport.JDCrashReportConfig;
import com.jingdong.sdk.jdcrashreport.JdCrashReport;

import java.util.Map;


public class DemoApplication extends Application {

    private static DemoApplication mInstance;
    private String appId;

    @Override
    public void onCreate() {
        super.onCreate();
        mInstance = this;
        appId = "7fa48a76fbcd493ea63e9fdf65ab5da6";
        //initialize shooter
        Sentry.initialize(this, appId);
        LiveSDK.getInstance(this).init(Constant.APP_KEY, Constant.APP_SECRET_KEY, Constant.APP_ID);
        OkHttpUtil.getInstance().initHttp();
        OkHttpUtil.getInstance().setCache(this);

//        JDCrashReportConfig config = new JDCrashReportConfig
//                .Builder()
//                .setContext(getApplicationContext())
//                .setAppId(appId)//注册时申请的APP Key
//                .build();
//        JdCrashReport.init(config);
    }

    public static DemoApplication getContext() {
        return mInstance;
    }

    private static JDCloudVideoCache cache;

    public static JDCloudVideoCache getCache() {
        return cache == null ? (cache = mInstance.newCache()) : cache;
    }

    private JDCloudVideoCache newCache() {
        //边播放边下载的保存路径是应用内部存储，用户可在设置中对应用进行数据清理
        return new JDCloudVideoCache(mInstance.getExternalFilesDirs(Environment.DIRECTORY_DOWNLOADS)[0].getPath());
    }

}
