package com.jdcloud.media.demo.base;

import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;

import com.jdcloud.media.demo.utils.LogUtil;


public abstract class BaseActivity extends AppCompatActivity {

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initView();
        setActionBar();
        initData();
        initListener();
    }

    public abstract void initView();

    //子类根据实际情况实现
    public void setActionBar() {

    }

    public abstract void initData();

    public abstract void initListener();

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }

    public void startComponent(Class<?> clazz) {
        Intent i = new Intent(this, clazz);
        startActivity(i);
    }
}
