package com.jdcloud.media.demo.common.network;


import com.google.gson.Gson;

import java.net.URLEncoder;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

import okhttp3.MediaType;
import okhttp3.RequestBody;

public class HttpRequest {
    private static final String CHARSET_NAME = "UTF-8";

    private Map<String, String> params = new LinkedHashMap<>();

    private int method = Method.GET;

    public HttpRequest(int method) {
        this.method = method;
    }


    public HttpRequest putParam(String key, String value) {
        params.put(key, value);
        return this;
    }


    public HttpRequest putParams(Map<String, String> params) {
        if (params != null) {
            this.params.putAll(params);
        }
        return this;
    }

    public boolean isPost() {
        return method == Method.POST;
    }


    public RequestBody getRequestBody() {
        RequestBody body = null;
        Gson gson = new Gson();
        MediaType JSON = MediaType.get("application/json");
        try {
            body = RequestBody.create(JSON, gson.toJson(params));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return body;
    }


    public String getGetBody() {
        if(params.isEmpty()){
            return "";
        }
        Set<Map.Entry<String, String>> datas = params.entrySet();
        StringBuilder sb = new StringBuilder();
        String value = "";
        for (Map.Entry<String, String> data : datas) {
            value = data.getValue();
            try {
                value = URLEncoder.encode(value, CHARSET_NAME);
            } catch (Exception e) {
                e.printStackTrace();
            }
            sb.append(data.getKey() + "=" + value);
            sb.append("&");
        }
        sb.setLength(sb.length() - 1);
        return sb.toString();
    }


    public interface Method {
        int DEPRECATED_GET_OR_POST = -1;
        int GET = 0;
        int POST = 1;
    }
}
