package com.jdcloud.media.demo.player;

import android.content.Context;
import android.graphics.Color;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import com.jdcloud.media.demo.R;
import com.jdcloud.media.player.wrapper.JDCloudVideoView;
import com.jdcloud.media.player.wrapper.view.IRenderView;

public enum GlobalPlayer {
    INSTANCE;

    private JDCloudVideoView mPlayer;

    public void initPlayer(Context context) {
        if (mPlayer != null) {
            mPlayer.release(false);
            mPlayer = null;
        }

        this.mPlayer = new JDCloudVideoView(context);
        //设置JDCloudVideoView和父布局大小一样，父布局高度固定。
        this.mPlayer.setLayoutParams(new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT,ViewGroup.LayoutParams.MATCH_PARENT));
//        this.mPlayer.setBackgroundColor(Color.GREEN);
    }

    public JDCloudVideoView getInstance() {
        return mPlayer;
    }

    public void destroy() {
        if (mPlayer != null)
            mPlayer.release(false);
        mPlayer = null;
    }
}
