package com.jdcloud.media.demo.player.cotent;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.jdcloud.media.demo.player.BasePlayerActivity;

public abstract class BaseFragment extends android.support.v4.app.Fragment {

    private BasePlayerActivity mActivity;
    public View mView;

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        this.mActivity = (BasePlayerActivity) activity;
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        this.mActivity = (BasePlayerActivity) context;
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        mView = inflater.inflate(getLayoutId(), container, false);

        initViews();
        initData();
        initListener();
        return mView;
    }

    public abstract int getLayoutId();

    public abstract void initViews();

    public abstract void initData();

    public abstract void initListener();

    public BasePlayerActivity getMyActivity() {
        return mActivity;
    }
}