package com.jdcloud.media.demo.player.cotent;


import android.app.AlertDialog;
import android.content.DialogInterface;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.jdcloud.media.demo.R;
import com.jdcloud.media.demo.common.Constant;
import com.jdcloud.media.demo.common.network.BaseResponse;
import com.jdcloud.media.demo.common.network.HttpRequest;
import com.jdcloud.media.demo.common.network.OkHttpUtil;
import com.jdcloud.media.demo.common.network.ResponseCallback;
import com.jdcloud.media.demo.player.adapter.VideoAdapter;
import com.jdcloud.media.demo.player.bean.Result;
import com.jdcloud.media.demo.player.bean.Stream;
import com.jdcloud.media.demo.player.bean.VideoBean;
import com.jdcloud.media.demo.utils.LogUtil;
import com.jdcloud.media.demo.utils.ToastUtil;

import java.util.ArrayList;
import java.util.List;

public class LiveListFragment extends BaseFragment {

    private final static String TAG = LiveListFragment.class.getSimpleName();
//    private List<Result> resultList = null;//网络请求的列表
    private List<VideoBean> resultList = null;//网络请求或自己封装的列表
    RecyclerView mLiveListRV;
    RelativeLayout rlRetry;
    ProgressBar pb_request;
    TextView tvRetry;
    private VideoAdapter mAdapter;
//    private List<VideoBean> mLiveList = new ArrayList<>();
    @Override
    public int getLayoutId() {
        return R.layout.fragment_vod_list;
    }

    @Override
    public void initData() {
        resultList = new ArrayList<>();
        mAdapter = new VideoAdapter(getMyActivity(), resultList, Constant.PLAYER.TYPE_LIVE);
        mLiveListRV.setLayoutManager(new LinearLayoutManager(getMyActivity(), LinearLayoutManager.VERTICAL, false));
        mLiveListRV.setAdapter(mAdapter);
        requestData();
    }

    private void requestData(){
        mLiveListRV.setVisibility(View.GONE);
        rlRetry.setVisibility(View.VISIBLE);
        pb_request.setVisibility(View.VISIBLE);
        tvRetry.setVisibility(View.GONE);
        if(!OkHttpUtil.checkConnect(getContext())){
            rlRetry.setVisibility(View.VISIBLE);
            pb_request.setVisibility(View.GONE);
            tvRetry.setVisibility(View.VISIBLE);
            mLiveListRV.setVisibility(View.GONE);
            return;
        }
        OkHttpUtil.getInstance().doRequest(Constant.REQUEST_URL_LIVE, "live",null,HttpRequest.Method.GET, new ResponseCallback<BaseResponse>() {
            @Override
            public void onSuccess(BaseResponse baseResponse) {
                rlRetry.setVisibility(View.GONE);
                pb_request.setVisibility(View.GONE);
                LogUtil.e("OkHttpUtil","URL："+Constant.REQUEST_URL_LIVE+"\nbaseResponse:"+baseResponse.toString());
                if (baseResponse != null && baseResponse.getResult()!=null) {
                    if(resultList.size()>0){
                        resultList.clear();
                    }
                    resultList.addAll(baseResponse.getResult());
                    mAdapter.notifyDataSetChanged();
                    mLiveListRV.setVisibility(View.VISIBLE);
                }else{
//                    loadVideo();
                    ToastUtil.makeText(getActivity(),"live未请求到数据",Toast.LENGTH_SHORT);
                }
            }
            @Override
            public void onError(String tag, int errorCode) {
//                LogUtil.d("OkHttpUtil", "request live list error " + message + "  errorCode is " + errorCode);
//                ToastUtil.makeText(getActivity(),tag+"请求失败",Toast.LENGTH_SHORT);
                rlRetry.setVisibility(View.VISIBLE);
                pb_request.setVisibility(View.GONE);
                tvRetry.setVisibility(View.VISIBLE);
                mLiveListRV.setVisibility(View.GONE);
//                loadVideo();
            }
        });
    }
    private void loadVideo(){
        if (resultList.size()==0) {
            VideoBean vb0 = new VideoBean("京东云(RTMP HD)", 0, "rtmp://pl.jdcloud.com/live/CMCC_lhd", "https://pic.wenwen.soso.com/p/20151226/20151226114326-558979764.jpg");
            resultList.add(vb0);
            VideoBean vb1 = new VideoBean("京东云(RTMP SD)", 0, "rtmp://pl.jdcloud.com/live/CMCC_lsd", "https://pic.wenwen.soso.com/p/20151226/20151226114326-558979764.jpg");
            resultList.add(vb1);
            VideoBean vb2 = new VideoBean("京东云(RTMP SD)", 0, "rtmp://pl.jdcloud.com/live/CMCC_lld", "https://pic.wenwen.soso.com/p/20151226/20151226114326-558979764.jpg");
            resultList.add(vb2);
            VideoBean vb3 = new VideoBean("河北卫视(HLS直播)", 0, "http://weblive.hebtv.com/live/hbws_bq/index.m3u8", "https://pic.wenwen.soso.com/p/20151226/20151226114326-558979764.jpg");
            resultList.add(vb3);

//            for (int i = 0; i < 4; i++) {
//                if (i == 0) {
//                    vb = new VideoBean("京东云直播测试视频" + i, 5000 + i * 1000, "rtmp://114.80.161.132/live?vhost=live.kksmg.com/dtv5cac91bb_884e43c1b0448869a69d6090", "https://pic.wenwen.soso.com/p/20151226/20151226114326-558979764.jpg");
////                    vb = new VideoBean("京东云直播测试视频" + i, 5000 + i * 1000, "rtmp://pl.jdcloud.com/live/CT", "https://pic.wenwen.soso.com/p/20151226/20151226114326-558979764.jpg");
//                } else if (i == 1) {
////                    vb = new VideoBean("京东云直播测试视频" + i, 5000 + i * 1000, "rtmp://pl.jdcloud.com/live/CMCC", "https://pic.wenwen.soso.com/p/20151226/20151226114553-1874996651.jpg");
//                    vb = new VideoBean("京东云直播测试视频" + i, 5000 + i * 1000, "http://weblive.hebtv.com/live/hbws_bq/index.m3u8", "https://pic.wenwen.soso.com/p/20151226/20151226114553-1874996651.jpg");
//                } else if(i==2){
////                    vb = new VideoBean("京东云直播测试视频" + i, 5000 + i * 1000, "rtmp://pl.jdcloud.com/live/CU", "https://pic.wenwen.soso.com/p/20151226/20151226114555-574259897.jpg");
//                    vb = new VideoBean("京东云直播测试视频" + i, 5000 + i * 1000, "http://weblive.hebtv.com/live/hbws_bq/index.m3u8", "https://pic.wenwen.soso.com/p/20151226/20151226114555-574259897.jpg");
//                }else if(i==3){
//                    vb = new VideoBean("京东云直播测试延禧攻略" + i, 5000 + i * 1000, "rtmp://114.80.161.132/live?vhost=live.kksmg.com/dtv5cac91bb_884e43c1b0448869a69d6090", "https://pic.wenwen.soso.com/p/20151226/20151226114555-574259897.jpg");
//                }
//                mLiveList.add(vb);
//            }
        }
        mAdapter.notifyDataSetChanged();
    }
    @Override
    public void initViews() {
        mLiveListRV = mView.findViewById(R.id.rv_vod_list);
        rlRetry= mView.findViewById(R.id.rlRetry);
        pb_request= mView.findViewById(R.id.pb_request);
        tvRetry=mView.findViewById(R.id.tvRetry);
    }

    @Override
    public void initListener() {
        mAdapter.setClickListener(new VideoAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(View view) {
                final int position = mLiveListRV.getChildAdapterPosition(view);
                final VideoBean bean = (resultList.get(position));
                if (OkHttpUtil.checkConnect(getContext())) {
                    if (OkHttpUtil.isWifi(getContext())) {
                        //wifi播放
                        mAdapter.updateSelectPosition(position);
                        getMyActivity().play(bean, false, Constant.PLAYER.TYPE_LIVE);
                    } else {
                        //非wifi需要用户确认后再播放
                        AlertDialog.Builder builder = new AlertDialog.Builder(getContext());
                        builder.setTitle("提示信息").setMessage("当前网络环境不是WIFI，是否继续播放?").setPositiveButton("继续", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                // TODO Auto-generated method stub
                                mAdapter.updateSelectPosition(position);
                                getMyActivity().play(bean, false, Constant.PLAYER.TYPE_LIVE);
                            }
                        }).setNegativeButton("取消", new DialogInterface.OnClickListener() {

                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                // TODO Auto-generated method stub
                                dialog.dismiss();
                            }
                        }).setCancelable(false).show();
                    }
                }
            }
        });
        rlRetry.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                requestData();
            }
        });
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        OkHttpUtil.getInstance().cancelTag("live");
    }

    public VideoBean getFirstVideo() {
        if (resultList != null && resultList.size() > 0) {
            mAdapter.updateSelectPosition(0);
//            if(resultList.get(0) instanceof Result){
//                return (Result) (resultList.get(0));
//            }
            return (resultList.get(0));
        }
        return null;
    }

    public VideoBean getNextVideo(boolean needPlay) {
        if (resultList != null && resultList.size() > 0) {
            int nextPos = mAdapter.getSelectedPosition() + 1;
            if (nextPos != mAdapter.getItemCount()) {
                if(needPlay){
                    mAdapter.updateSelectPosition(nextPos);
                }
//                if(resultList.get(nextPos) instanceof Result){
//                    return (Result)(resultList.get(nextPos));
//                }
                return (resultList.get(nextPos));
            }
        }
        return null;
    }

    public int getSelect() {
        return mAdapter.getSelectedPosition();
    }
    public void refreshUI(int position) {
        if (mAdapter != null) {
            mAdapter.updateSelectPosition(position);
        }
    }
}
