package com.jdcloud.media.demo.player.cotent;


import android.os.AsyncTask;
import android.os.Handler;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.jdcloud.media.demo.R;
import com.jdcloud.media.demo.common.Constant;
import com.jdcloud.media.demo.player.adapter.VideoAdapter;
import com.jdcloud.media.demo.player.bean.LocalVideo;
import com.jdcloud.media.demo.player.bean.VideoBean;
import com.jdcloud.media.demo.player.cotent.local.VideoProvider;
import com.jdcloud.media.demo.utils.ToastUtil;

import java.util.ArrayList;
import java.util.List;

public class LocalListFragment extends BaseFragment {

    RecyclerView mVodListRV;
    private VideoAdapter mAdapter;
    private List<LocalVideo> mLocalList = new ArrayList<>();
    private Handler mHandler;
    @Override
    public int getLayoutId() {
        return R.layout.fragment_vod_list;
    }

    @Override
    public void initData() {
        mHandler = new Handler();
        mAdapter = new VideoAdapter(getMyActivity(), mLocalList,Constant.PLAYER.TYPE_LOCAL);
        mVodListRV.setLayoutManager(new LinearLayoutManager(getMyActivity(), LinearLayoutManager.VERTICAL, false));
        mVodListRV.setAdapter(mAdapter);
        AsyncTask.execute(new Runnable() {
            @Override
            public void run() {
                VideoProvider vp = new VideoProvider(getMyActivity());
                if ( vp.getList() !=null) {
                    mLocalList.addAll(vp.getList());
                    mHandler.post(new Runnable() {
                        @Override
                        public void run() {
//                            mAdapter.updateData(mLocalList, Constant.PLAYER.TYPE_LOCAL);
                            mAdapter.notifyDataSetChanged();
                        }
                    });
                }else{
                    ToastUtil.makeText(getActivity(),"未获取到本地视频", Toast.LENGTH_SHORT);
                }
            }
        });
    }

    @Override
    public void initViews() {
        mVodListRV = mView.findViewById(R.id.rv_vod_list);
    }

    @Override
    public void initListener() {
        mAdapter.setClickListener(new VideoAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(View view) {
                int position = mVodListRV.getChildAdapterPosition(view);
                mAdapter.updateSelectPosition(position);
                LocalVideo lv = mLocalList.get(position);
//                lv.setVideoURL(lv.path);
////                lv.video_type = Constant.PLAYER.TYPE_LOCAL;
//                lv.duration = lv.duration;
                getMyActivity().play(lv, false,Constant.PLAYER.TYPE_LOCAL);
            }
        });
    }
    public VideoBean getFirstVideo(){
        if(mLocalList!=null && mLocalList.size()>0){
            mAdapter.updateSelectPosition(0);
            return mLocalList.get(0);
        }
        return null;
    }

    public VideoBean getNextVideo(boolean needPlay){
        if(mLocalList!=null && mLocalList.size()>0){
            int nextPos = mAdapter.getSelectedPosition() + 1;
            if (nextPos != mAdapter.getItemCount()) {
                if(needPlay){
                    mAdapter.updateSelectPosition(nextPos);
                }
                return mLocalList.get(nextPos);
            }
        }
        return null;
    }
    public int getSelect(){
        return mAdapter.getSelectedPosition();
    }
    public void refreshUI(int position) {
        if (mAdapter != null) {
            mAdapter.updateSelectPosition(position);
        }
    }
}
