package com.jdcloud.media.demo.player.cotent;


import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.View;

import com.jdcloud.media.demo.R;
import com.jdcloud.media.demo.player.adapter.LogAdapter;
import com.jdcloud.media.demo.player.bean.LogBean;
import com.jdcloud.media.demo.utils.CommonUtils;
import com.jdcloud.media.demo.utils.LogUtil;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.util.ArrayList;
import java.util.List;


public class LogListFragment extends BaseFragment {

    private static final String TAG = LogListFragment.class.getSimpleName();

    private List<LogBean> mLogList = new ArrayList<>();
    private LogAdapter mAdapter;
    RecyclerView mLogListRV;

    private int count=0;

    @Override
    public int getLayoutId() {
        return R.layout.fragment_log_list;
    }

    @Override
    public void initData() {
//        LogBean logBean = new LogBean();
//        logBean.setTime(CommonUtils.timeFormat());
//        logBean.setLog("第1个视频start send log ----------");
//        mLogList.add(logBean);
        mAdapter = new LogAdapter(getMyActivity(), mLogList);
        mLogListRV.setLayoutManager(new LinearLayoutManager(getMyActivity(), LinearLayoutManager.VERTICAL, false));
        mLogListRV.setAdapter(mAdapter);
    }

    @Override
    public void onStop() {
        super.onStop();
        EventBus.getDefault().unregister(this);
    }

    @Override
    public void initViews() {
        mLogListRV = mView.findViewById(R.id.rv_log_list);
//        LogUtil.i("BLAY", "LogListFragment:initViews注册eventbus" );
        EventBus.getDefault().register(this);
    }

    @Override
    public void initListener() {
        mAdapter.setClickListener(new LogAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(View view) {
                //todo
            }
        });
    }

    @Subscribe(threadMode = ThreadMode.MAIN,sticky = true)
    public void onMessageEvent(LogBean bean) {
//        LogUtil.i("BLAY", "onMessageEvent bean is " + bean.getTime() + bean.getLog());
//        LogUtil.i("BLAY", "该消息是第" + mLogList.size()+"条消息");
        if("clear".equals(bean.getLog()) && "clear".equals(bean.getTime())){
            mLogList.clear();
            count++;
            LogBean logBean = new LogBean();
            logBean.setTime(CommonUtils.timeFormat());
            logBean.setLog("第"+count+"个视频start send log ----------");
            mLogList.add(logBean);
        }else{
            mLogList.add(bean);
        }
        if (mAdapter != null) {
            mAdapter.updateData(mLogList);
        }
    }

    public void initLog(){
    }
}
