package com.jdcloud.media.demo.player.cotroller;

import android.content.Context;
import android.content.Intent;
import android.graphics.RectF;
import android.net.Uri;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.provider.MediaStore;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.constraint.ConstraintLayout;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.MediaController;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.jdcloud.media.demo.R;
import com.jdcloud.media.demo.common.Constant;
import com.jdcloud.media.demo.player.bean.Stream;
import com.jdcloud.media.demo.player.bean.VideoBean;
import com.jdcloud.media.demo.player.widget.FullMoreView;
import com.jdcloud.media.demo.player.widget.JDPlayerView;
import com.jdcloud.media.demo.player.widget.SpeedView;
import com.jdcloud.media.demo.player.widget.StreamView;
import com.jdcloud.media.demo.player.widget.VideoSeekBar;
import com.jdcloud.media.demo.utils.CommonUtils;
import com.jdcloud.media.demo.utils.LogUtil;
import com.jdcloud.media.demo.utils.ToastUtil;
import com.jdcloud.media.player.jdcplayer.IMediaPlayer;
//import com.jdcloud.media.player.wrapper.JDCloudVideoTool;
import com.jdcloud.media.player.wrapper.JDCloudVideoView;
import com.jdcloud.media.player.wrapper.PlayerConfig;
import com.jdcloud.media.player.wrapper.util.FFmpegCallback;
import com.jdcloud.media.player.wrapper.view.IRenderView;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;


/**
 *全屏播放界面
 */
public class JDCMediaControllerFull extends JDCMediaControllerBase {
    private static final String TAG = "JDCMediaControllerFull";
    @BindView(R.id.rl_controller_top)
    RelativeLayout mLayoutTop;
    @BindView(R.id.rl_controller_full_bottom)
    RelativeLayout mLayoutBottom;
    @BindView(R.id.iv_controller_back)
    ImageView mIvBack;
    @BindView(R.id.iv_controller_full_play)
    ImageView mIvPause;
    @BindView(R.id.tv_controller_full_clarity)
    TextView mTvQuality;
    //几倍速
    @BindView(R.id.tv_controller_full_speed)
    TextView mTvSpeed;
    @BindView(R.id.tv_controller_title)
    TextView mTvTitle;
    @BindView(R.id.iv_player_lock)
    ImageView mIvLock;
    @BindView(R.id.iv_controller_more)
    ImageView mIvMore;
    @BindView(R.id.sb_controller_full)
    SeekBar mSeekProgress;
    @BindView(R.id.tv_controller_full_current)
    TextView mTvCurrent;
    @BindView(R.id.ll_controller_full_duration)
    LinearLayout ll_controller_full_duration;
    @BindView(R.id.tv_controller_full_duration)
    TextView mTvDuration;
    @BindView(R.id.ll_controller_full_cut_gif)
    LinearLayout mCutGifLL;
    @BindView(R.id.controller_full_more)
    FullMoreView mFullMoreView;
    @BindView(R.id.controller_full_speed)
    SpeedView mSpeedView;
    @BindView(R.id.controller_full_stream)
    StreamView mStreamView;
    @BindView(R.id.rl_player_cut)
    RelativeLayout mCutRl;

    @BindView(R.id.rl_player_gif)
    RelativeLayout mGifRl;
    @BindView(R.id.rlControllerFull)
    RelativeLayout rlControllerFull;
    @BindView(R.id.clGifMain)
    ConstraintLayout clGifMain;
    @BindView(R.id.vsbGIF)
    VideoSeekBar vsbGIF;
    @BindView(R.id.jdc_player_view)
    JDCloudVideoView mPlayerView;//播放gif小视频的播放器
//    String videoPath;
    @BindView(R.id.pb_live)
    ProgressBar pb_live;//加载视频和录制短视频的进度条
    @BindView(R.id.pb_live_gif)
    ProgressBar pb_live_gif;//加载gif录制短视频的进度条
    @BindView(R.id.pb_gif_save)
    ProgressBar pb_gif_save;//生成gif图片的进度条
    private String gifFileName;

    private Context mContext;

    private final int MSG_UPDATE_SAVEGIF=10;
    private static final int MSG_GIF_SNAP_COMPLETE_ERROR = 999;
    private static final int MSG_GIF_SNAP_COMPLETE_CORREST = 998;
    private static final int MSG_GIFMAKE_COMPLETE = 997;
    private static final int MSG_GIFMAKE_ERROR = 996;

    private Handler handler=new Handler(Looper.getMainLooper()){
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case MSG_UPDATE_SAVEGIF:
                    LogUtil.d("BLAY","更新进度："+msg.arg1);
                    pb_gif_save.setProgress(msg.arg1);
                    break;
                case MSG_GIF_SNAP_COMPLETE_CORREST:
                    String path0=CommonUtils.getGifTemp(mContext);
                    final File appDir0 = new File(path0);
                    if(!appDir0.exists() || appDir0.listFiles().length==0){
                        LogUtil.d("BLAY", "没有生成gif图片序列");
                        ToastUtil.makeText(getContext(),"没有生成gif图片序列",Toast.LENGTH_SHORT);
                        toControllerFull(false);
                    }else{
                        vsbGIF.buildThumbs();
                    }
                     break;
                case MSG_GIFMAKE_COMPLETE:
                    toControllerFull(true);
                    break;
                case MSG_GIF_SNAP_COMPLETE_ERROR:
                    String path=CommonUtils.getGifTemp(mContext);
                    final File appDir = new File(path);
                    if(appDir.exists() && appDir.listFiles().length>0){
                        LogUtil.d("BLAY", "delete all files of jdcplayer/gifTemp");
                        //清除以前保存的图片序列
                        CommonUtils.delFolder(path);
                    }
                    toControllerFull(false);
                    break;
                case MSG_GIFMAKE_ERROR:
//                    String path1=CommonUtils.getGifVideo(mContext);
//                    final File appDir1 = new File(path1);
//                    if(appDir1.exists() && appDir1.listFiles().length>0){
//                        LogUtil.d("BLAY", "delete all files of jdcplayer/gifTemp");
//                        //清除以前保存的图片序列
//                        CommonUtils.delFolder(path1);
//                    }
                    toControllerFull(false);
                    break;
                default:
                    break;
            }
//            super.handleMessage(msg);
        }
    };
    public JDCMediaControllerFull(@NonNull Context context) {
        super(context);
        this.mContext=context;
        initViews();
    }

    public JDCMediaControllerFull(@NonNull Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        this.mContext=context;
        initViews();
    }

    public void setSpeedCallback(SpeedView.SpeedCallback callback) {
        mSpeedView.setCallback(callback);
    }

    public void setStreamCallback(StreamView.StreamCallback callback) {
        mStreamView.setCallback(callback);
    }

    @Override
    public void onShow() {
        mLayoutTop.setVisibility(View.VISIBLE);
        mLayoutBottom.setVisibility(View.VISIBLE);
    }

    @Override
    public void onHide() {
        mLayoutTop.setVisibility(View.GONE);
        mLayoutBottom.setVisibility(View.GONE);
        mFullMoreView.setVisibility(View.GONE);
        mSpeedView.setVisibility(View.GONE);
        mStreamView.setVisibility(View.GONE);
        mCutGifLL.setVisibility(View.VISIBLE);
//        pb_live_gif.setVisibility(View.GONE);
    }

    /**
     * 判断是否点击上下黑色透明控制局部
     * @param event
     * @return
     */
    @Override
    public boolean touchControlBar(MotionEvent event) {
        int[] location = new int[2];
        mLayoutTop.getLocationOnScreen(location);
        RectF topRect=new RectF(location[0], location[1], location[0] + mLayoutTop.getWidth(), location[1] + mLayoutTop.getHeight());
        boolean topContains = topRect.contains(event.getX(), event.getY());

        mLayoutBottom.getLocationOnScreen(location);
        RectF bottomRect=new RectF(location[0], location[1], location[0] + mLayoutBottom.getWidth(), location[1] + mLayoutBottom.getHeight());
        boolean bottomContains = bottomRect.contains(event.getX(), event.getY());

        return topContains||bottomContains;

    }

    private void initViews() {
        mLayoutInflater.inflate(R.layout.layout_controller_full, this);
        ButterKnife.bind(this);
        mProgress = findViewById(R.id.full_gesture_progress);
        tvTimeToast=findViewById(R.id.tvTimeToast);

        mSeekProgress.setOnSeekBarChangeListener(this);
//        if (mDefaultVideoQuality != null) {
//            mTvQuality.setText(mDefaultVideoQuality.getName());
//        }
        //添加日志类型
        PlayerConfig config = new PlayerConfig();
        config.setNativeLogLevel(PlayerConfig.LOG_ERROR);
        mPlayerView.setPlayerConfig(config);
        mPlayerView.setOnPreparedListener(new IMediaPlayer.OnPreparedListener() {
            @Override
            public void onPrepared(IMediaPlayer iMediaPlayer) {
                mPlayerView.setLooping(true);
            }
        });
    }

    public void setCallBack(MoreCallback callBack) {
        mFullMoreView.setCallBack(callBack);
    }

    @OnClick(R.id.iv_controller_back)
    public void backToNormal() {
        if (pb_live.getVisibility()==VISIBLE && !mController.isPlaying() ){
            ToastUtil.makeText(mContext,"取消gif截屏",Toast.LENGTH_SHORT);
            pb_live.setVisibility(View.GONE);
            LogUtil.d("BLAY", "JDCloudVideoTool：FFmpegExecutor.terminateFFmpeg()" );
//            JDCloudVideoTool.cancel();
        }else{
            mController.onBackPressed(Constant.PLAYER.PLAY_MODE_FULL);
        }
    }

    @OnClick(R.id.ll_controller_replay)
    public void replay() {
        mController.onReplay();
    }

    @OnClick(R.id.tv_controller_full_speed)
    public void speedChange() {
        mSpeedView.setVisibility(View.VISIBLE);
        mCutGifLL.setVisibility(View.GONE);
    }

    @OnClick(R.id.rl_player_cut)
    public void snapShut() {
        mController.onCutScreen();
    }

    @OnClick(R.id.rl_player_gif)
    public void gitCut() {
        mController.onGIFPress();
    }

    @OnClick(R.id.iv_player_lock)
    public void changeLockState() {
        mLockScreen = !mLockScreen;
        if (mLockScreen) {
            mIvLock.setImageResource(R.drawable.ic_lock);
            mCutRl.setVisibility(View.GONE);
            mGifRl.setVisibility(View.GONE);
            hide();
        } else {
            mIvLock.setImageResource(R.drawable.ic_unlock);
            mCutRl.setVisibility(View.VISIBLE);
            mCutGifLL.setVisibility(View.VISIBLE);
            if(mController.getPlayType()==Constant.PLAYER.TYPE_VOD){
                mGifRl.setVisibility(View.VISIBLE);
            }else{
                mGifRl.setVisibility(View.GONE);
            }
        }
    }

    @OnClick(R.id.rl_player_lock)
    public void changeLock() {
        changeLockState();
    }

    @OnClick(R.id.iv_controller_full_play)
    public void changePlayState() {
        // 播放中
        if (mController.isPlaying()) {
            mController.pause();
            mIvPause.setImageResource(R.drawable.ic_player_pause);
//            JDPlayerView.PLAY_STATE=Constant.PLAYER.STATE_PAUSED;
//            SharePreferenceUtil.getInstance().setIsPlaying(false);
            show();
        }
        // 未播放
        else if (!mController.isPlaying()) {
            mController.start();
            mIvPause.setImageResource(R.drawable.ic_player_play);
            show();
//            JDPlayerView.PLAY_STATE=Constant.PLAYER.STATE_PLAYING;
//            SharePreferenceUtil.getInstance().setIsPlaying(true);
        }
    }

    @OnClick(R.id.iv_controller_full_next)
    public void iv_controller_full_next() {
        mController.onNextVideo();
    }


    @OnClick(R.id.iv_controller_more)
    public void showMoreView() {
        mFullMoreView.initBackgroundUi(mController.isBackgroundPlay());
        mFullMoreView.updateMirrorUi(mController.isMirror());
        mFullMoreView.setVisibility(View.VISIBLE);
        mCutGifLL.setVisibility(View.GONE);
    }

    @OnClick(R.id.tv_controller_full_clarity)
    public void showQualityView() {
        //选择清晰度
        if (mVideoQualityList == null || mVideoQualityList.size() == 0) {
            ToastUtil.makeText(mContext,"只有一个清晰度",Toast.LENGTH_SHORT);
            return;
        }
//        mStreamView.setStreamList(mVideoQualityList);
        mStreamView.setVisibility(View.VISIBLE);
        mCutGifLL.setVisibility(View.GONE);
    }
    public void setVideoQualityList(List<Stream> list){
        mStreamView.setStreamList(list);
        super.setVideoQualityList(list);
    }
    public void updateQualityText(String name) {
//        mDefaultVideoQuality = videoQuality;
//        if(name.equals(mTvQuality.getText())){
//            return  false;
//        }
        if (mTvQuality != null) {
            mTvQuality.setText(name);
        }
//        return true;
//        mStreamView.initDefaultStream(videoQuality);
    }

    /**
     * 播放中,更新播放和暂停按钮
     */
    public void updatePlayState() {
        // 播放中
            if (mController.isPlaying()){
                mIvPause.setImageResource(R.drawable.ic_player_play);
            }else {// 未播放
                mIvPause.setImageResource(R.drawable.ic_player_pause);
            }
        if(mController.isPlaying() || JDPlayerView.PLAY_STATE==Constant.PLAYER.ERROR){
            pb_live.setVisibility(GONE);
        }else if(JDPlayerView.PLAY_STATE==Constant.PLAYER.IDLE || JDPlayerView.PLAY_STATE == Constant.PLAYER.SEEKING){
            pb_live.setVisibility(VISIBLE);
        }
    }


    public void setDuration(){
//        if (JDPlayerView.PLAY_STATE == Constant.PLAYER.PREPARED) {
            duration = mController.getDuration();
            if (mTvDuration != null && duration != 0) {
                mTvDuration.setText(CommonUtils.formattedTime(duration));
            }
//        }

    }


//    public void updateTitle(String title) {
//        super.updateTitle(title);
//
//    }

    public void updateVideoProgress(int mPlayType,long current) {
        if(JDPlayerView.PLAY_STATE == Constant.PLAYER.IDLE){
            if (mTvCurrent != null) mTvCurrent.setText(CommonUtils.formattedTime(current));
            if (mTvDuration != null ) mTvDuration.setText(CommonUtils.formattedTime(0));
            mSeekProgress.setProgress(0);
            return;
        }

        if (mTvCurrent != null) mTvCurrent.setText(CommonUtils.formattedTime(current));
        if(tvTimeToast.getVisibility()!=VISIBLE){
            //拖动进度条时就不用更新了
            float percentage = duration > 0 ? (float) (current * 1.0 / duration) : 0f;
            if (percentage >= 0 && percentage <= 1) {
                if (mSeekProgress != null && mPlayType != Constant.PLAYER.TYPE_LIVE ) {
                    int progress = Math.round(percentage * mSeekProgress.getMax());
                    mSeekProgress.setProgress(progress);
                    if(mTvDuration.getText().equals("00:00:00")){
                        mTvDuration.setText(CommonUtils.formattedTime(duration));
                    }
                }
            }
        }
    }

    /**
     * 每次切换视频，需要更新界面
     * @param video 视频数据
     */
    public void updateUI(VideoBean video,int mPlayType) {
//        super.updatePlayType(playType);
        mTvTitle.setText(video.getName());
        //每次更新视频需要把倍速调整为1
        mTvSpeed.setText("1倍速");
        mSpeedView.reset();
        switch (mPlayType) {
            case Constant.PLAYER.TYPE_VOD:
                //点播
                ll_controller_full_duration.setVisibility(View.VISIBLE);
//                mSeekProgress.setEnabled(true);
                mSeekProgress.setVisibility(VISIBLE);
                mGifRl.setVisibility(View.VISIBLE);
                mTvSpeed.setVisibility(VISIBLE);
                break;
            case Constant.PLAYER.TYPE_LIVE:
                //直播
                ll_controller_full_duration.setVisibility(View.GONE);
//                mSeekProgress.setProgress(0);
//                mSeekProgress.setEnabled(false);
                mSeekProgress.setVisibility(GONE);
                mGifRl.setVisibility(View.GONE);
                mTvSpeed.setVisibility(GONE);
                break;
            case Constant.PLAYER.TYPE_LOCAL:
                //本地视频
                ll_controller_full_duration.setVisibility(View.VISIBLE);
//                mSeekProgress.setEnabled(true);
                mSeekProgress.setVisibility(VISIBLE);
                mGifRl.setVisibility(View.GONE);
                mTvSpeed.setVisibility(VISIBLE);
                mTvQuality.setText("");
                break;
            case Constant.PLAYER.TYPE_URL:
                //扫码播放
//                ll_controller_full_duration.setVisibility(View.VISIBLE);
//                mSeekProgress.setEnabled(true);
                mGifRl.setVisibility(View.GONE);
                mTvQuality.setText("");
//                if(video.getVideoURL().startsWith("rtmp") || video.getVideoURL().startsWith("RTMP")){
                if(mController.getDuration()>0){
                    //点播或者本地
                    ll_controller_full_duration.setVisibility(View.VISIBLE);
                    mTvSpeed.setVisibility(VISIBLE);
                    mSeekProgress.setVisibility(VISIBLE);
                }else{
                    //直播
                    ll_controller_full_duration.setVisibility(View.GONE);
                    mTvSpeed.setVisibility(GONE);
                    mSeekProgress.setVisibility(GONE);
                }
                break;
        }
    }

    /**
     *  展示gif主界面,开始截屏
     */
    public void showGifLayout() {
        pb_live.setVisibility(GONE);//隐藏加载的进度条
        pb_live_gif.setVisibility(VISIBLE);
        pb_gif_save.setProgress(0);
        if(mController.getDuration()==0){
            ToastUtil.makeText(mContext,"未获取到视频时常",Toast.LENGTH_SHORT);
            return;
        }
        clGifMain.setVisibility(View.VISIBLE);
        rlControllerFull.setVisibility(View.GONE);
        playGifVideo();
//        vsbGIF.buildThumbs();
        vsbGIF.setChangeListener(new VideoSeekBar.ChangeListener() {
            @Override
            public void onChange(float startTime, float endTime) {
                //播放节选时间内的小视频
//                LogUtil.d("BLAY","onChange********************************startTime:"+startTime+",endTime："+endTime);

            }
        });
        String path=CommonUtils.getGifTemp(mContext);
        final File appDir = new File(path);
        if(appDir.exists() && appDir.listFiles().length>0){
//            LogUtil.d("BLAY", "delete all files of jdcplayer/gifTemp");
            //清除以前保存的图片序列
            CommonUtils.delFolder(path);
        }
        if (!appDir.exists()) {
            appDir.mkdirs();
        }
        String pathVideo=CommonUtils.getGifVideo(mContext);
        File file = new File(pathVideo,"output.mp4");
//        String videoUrl = "file://" + file.getPath() + "/" + file.listFiles()[0].getName();
        if(!file.exists()){
            ToastUtil.makeText(mContext,"未获取到短视频文件，无法截取图片序列",Toast.LENGTH_SHORT);
            return;
        }
        String videoUrl =pathVideo+"/" + "output.mp4";//获取小视频文件
        LogUtil.d("BLAY", " before getSnapShotSequence******************"+"url:\n"+videoUrl+"\n保存到："+ appDir.getPath());

//        JDCloudVideoTool.getSnapShotSequence(videoUrl, appDir.getPath(), 320, 1, 0, 10, new FFmpegCallback() {
//                @Override
//                public void onStart() {
//                    LogUtil.d("BLAY", "getSnapShotSequence:onStart");
//                }
//
//                @Override
//                public void onProgress(float i, int i1) {
//                    LogUtil.d("BLAY", "getSnapShotSequence:onProgress:" + i + "frame " + i1);
//                }
//
//                @Override
//                public void onCompletion(int i) {
//                    LogUtil.d("BLAY", "getSnapShotSequence:onCompletion----i="+i);
////                    Intent intent=new Intent(mContext,PlayerGIFActivity.class);
////                    intent.putExtra("videoUrl",videoBean.videoURL);
////                    intent.putExtra("currentSecond",currentSecond);
////                    ((BasePlayerActivity)mContext).startActivityForResult(intent,100);
//                    Message msg = Message.obtain();
//                    if(i==0){//成功
//                        msg.what = MSG_GIF_SNAP_COMPLETE_CORREST;
////                        msg.arg1 = currentSecond;
//                        handler.sendMessage(msg);
//                    }else{//未成功
//                        msg.what = MSG_GIF_SNAP_COMPLETE_ERROR;
//                        handler.sendMessage(msg);
//                    }
//                }
//            });

    }

    public void playGifVideo(){
        pb_live_gif.setVisibility(View.GONE);
        File appDir = new File(CommonUtils.getGifVideo(mContext));
        if(appDir.listFiles().length==0){
            ToastUtil.makeText(mContext,"出现错误，无小视频文件！",Toast.LENGTH_SHORT);
            return;
        }
        String audioPath = "file://" + appDir.getPath() + "/" + appDir.listFiles()[0].getName();
        LogUtil.d("BLAY", "----------------播放视频，audioPath:"+audioPath);
        mPlayerView.setVideoPath(audioPath);
        mPlayerView.start();
//        mPlayerView.setScalingMode(IRenderView.SCALING_MODE_ASPECT_FIT);
    }

    /**
     * @param saveGif 是否点击了保存gif图片返回到横屏主界面（还可能点击了取消）
     */
    public void toControllerFull(boolean saveGif) {
        if(saveGif){
            File appDir = new File(CommonUtils.getGifVideo(mContext));
//           String fileName=appDir.listFiles()[0].getName();
            if(gifFileName .endsWith("gif")){
                //该文件夹只会有一个小视频文件和一个gif文件
//                if(appDir.listFiles().length==1){
//                    ToastUtil.makeText(mContext,"未找到gif图片文件",Toast.LENGTH_SHORT);
//                }else{
//                    fileName=appDir.listFiles()[1].getName();
                    try {
                        MediaStore.Images.Media.insertImage(mContext.getContentResolver(),
                                appDir.getAbsolutePath(), gifFileName, null);
                    } catch (FileNotFoundException e) {
                        e.printStackTrace();
                    }
                    // 最后通知图库更新
                    mContext.sendBroadcast(new Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE, Uri.parse("file://" + appDir.getAbsolutePath()+"/"+gifFileName)));
                    ToastUtil.makeText(mContext," 保存成功 ",Toast.LENGTH_SHORT);
//                }
            }else{
                ToastUtil.makeText(mContext,"生成gif图片失败，请稍后再试！",Toast.LENGTH_SHORT);
            }
        }
        if(pb_live.getVisibility()==View.VISIBLE){
            //加载视频时候的进度条
            pb_live.setVisibility(View.GONE);
        }
        if(pb_live_gif.getVisibility()==View.VISIBLE){
            //gif截图时候的进度条
            pb_live_gif.setVisibility(View.GONE);
        }
        pb_gif_save.setProgress(0);
        clGifMain.setVisibility(View.GONE);
        rlControllerFull.setVisibility(View.VISIBLE);

        //暂停小视频，注意重复点击gif的情况
        mPlayerView.pause();
        mPlayerView.release(true);
        mController.start();
    }

    /**
     * 如果正在截图，或者正在生成gif需要取消
     */
    @OnClick(R.id.btnCancel)
    public void cancel() {
        //调用sdk中取消录制屏幕的回掉
//        if (pb_live.getVisibility()==VISIBLE || pb_live_gif.getVisibility()==VISIBLE){
        if (pb_gif_save.getProgress()>0 || pb_live_gif.getVisibility()==VISIBLE){
            LogUtil.d("BLAY", "JDCloudVideoTool：FFmpegExecutor.terminateFFmpeg()" );
//            JDCloudVideoTool.cancel();
        }
        toControllerFull(false);
    }

    @OnClick(R.id.btnSave)
    public void saveGIF() {
        if(pb_live_gif.getVisibility()==View.VISIBLE){
            ToastUtil.makeText(mContext,"正在加载视频，请稍后",Toast.LENGTH_SHORT);
            //正在录制小视频时，禁止录制gif
            return;
        }
        if (pb_gif_save.getProgress()>0){
            ToastUtil.makeText(mContext,"正在生成图片，请稍后",Toast.LENGTH_SHORT);
            return;
        }
        pb_gif_save.setProgress(0);
        int startTime = Math.round(vsbGIF.getStartTime() / 1000);
        int endTime = Math.round(vsbGIF.getEndTime() / 1000);
        LogUtil.d("BLAY", "生成gif图片的开始时间、结束时间：" + startTime + "-" + endTime);
        //生成gif并保存到相册
        String path=CommonUtils.getGifVideo(mContext);
        File file = new File(path);
//        String videoUrl = "file://" + file.getPath() + "/" + file.listFiles()[0].getName();
        String videoUrl =path+"/" + "output.mp4";//获取小视频文件
        LogUtil.d("BLAY", "videoUrl:" + videoUrl + ",savePath："+ file.getPath());
//        gifFileName=JDCloudVideoTool.recordGif(videoUrl, file.getPath(),320, 15, startTime, endTime, new FFmpegCallback() {
//            @Override
//            public void onStart() {
//                LogUtil.d("BLAY", "recordGif:onStart");
//            }
//
//            @Override
//            public void onProgress(float v, int i) {
//                LogUtil.d("BLAY", "recordGif:onProgress--"+v+","+i);
//                Message msg=Message.obtain();
//                msg.what=MSG_UPDATE_SAVEGIF;
//                msg.arg1=Math.round(v*10);
//                handler.sendMessage(msg);
//            }
//
//            @Override
//            public void onCompletion(int i) {
//                LogUtil.d("BLAY", "recordGif:onCompletion--"+i);
//                //保存完gif，最终回掉toControllerFull();
//                if(i==0){
//                    Message msg=Message.obtain();
////                    msg.what=MSG_GIFMAKE_COMPLETE;
////                    msg.obj=file
//                    handler.sendEmptyMessage(MSG_GIFMAKE_COMPLETE);
//                }else{
////                    ToastUtil.makeText(mContext,"保存gif图片出现错误，请稍后再试！",Toast.LENGTH_SHORT);
//                    handler.sendEmptyMessage(MSG_GIFMAKE_ERROR);
//                }
//            }
//        });
    }

//    public void canGif(boolean can) {
//        if (can) {
//
//        } else {
//            mGifRl.setVisibility(View.GONE);
//        }
//    }
    public boolean isLoading(){
        return pb_live.getVisibility()==View.VISIBLE;
    }
    public void showProgressBar(){
        pb_live.setVisibility(View.VISIBLE);
    }
//    public void hindProgressBar(){
//        pb_live.setVisibility(View.GONE);
//    }
    public void setSpeedText(String speed){
        mTvSpeed.setText(speed+"倍速");
        mSpeedView.setVisibility(View.GONE);
        mCutGifLL.setVisibility(View.VISIBLE);
    }

    public void pause(){
        LogUtil.e("BLAY","*************************mPlayerView.pause()");
        mPlayerView.pause();
        mPlayerView.release(true);
    }

    @Override
    public boolean onTouchEvent(MotionEvent event) {
        int action = event.getAction();
        if (action == MotionEvent.ACTION_DOWN) {
            if (pb_live.getVisibility()==VISIBLE && !mController.isPlaying() ){
                ToastUtil.makeText(mContext,"取消gif截屏",Toast.LENGTH_SHORT);
            //正在截取gif图片序列
            pb_live.setVisibility(GONE);
            LogUtil.d("BLAY", "JDCloudVideoTool：FFmpegExecutor.terminateFFmpeg()" );
//            JDCloudVideoTool.cancel();//取消后会走recordVideo:onCompletion*********i=-1，继续播放视频
//            toControllerFull(false);
            return true;
           }
        }
       return super.onTouchEvent(event);
    }

    public boolean onBackPressed(){
        if(clGifMain.getVisibility()==VISIBLE){
            //展示小视频播放界面的处理
            toControllerFull(false);
            return true;
        }else if(isLoading()){
            if(JDPlayerView.PLAY_STATE == Constant.PLAYER.PAUSED){
//                JDCloudVideoTool.cancel();
                return true;
            }
        }
        return false;
    }

//    @Override
//    public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
//        if(tvTimeToast.getVisibility()==View.VISIBLE){
////            tvTimeToast.setText("progress:"+progress);
////            seekBar.setMax();
//
//           String showTime=mController.getCurrentPlayTime(progress,seekBar.getMax());
//           LogUtil.e("BLAY","progress,seekBar.getMax()-----"+progress+","+seekBar.getMax());
//           tvTimeToast.setText(showTime);
//        }
//        super.onProgressChanged(seekBar,progress,fromUser);
//    }

}
