package com.jdcloud.media.demo.player.widget;

import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;

import com.jdcloud.media.demo.R;

import butterknife.BindView;
import butterknife.ButterKnife;

public class CustomProgressBar extends RelativeLayout {
    @BindView(R.id.iv_player_center)
    ImageView mCenter;
    @BindView(R.id.pb_player_seek)
    ProgressBar mSeekBar;
    private HideRunnable mHideRunnable;
    private int duration = 1000;

    public CustomProgressBar(Context context) {
        super(context);
        init(context);
    }

    public CustomProgressBar(Context context, AttributeSet attrs) {
        super(context, attrs);
        init(context);
    }

    private void init(Context context) {
        LayoutInflater.from(context).inflate(R.layout.layout_video_progress, this);
        ButterKnife.bind(this);
        mHideRunnable = new HideRunnable();
        setVisibility(GONE);
    }

    public void show() {
        setVisibility(VISIBLE);
        removeCallbacks(mHideRunnable);
        postDelayed(mHideRunnable, duration);
    }

    public void setProgress(int progress) {
        mSeekBar.setProgress(progress);
    }

    public void setDuration(int duration) {
        this.duration = duration;
    }

    public void setImageResource(int resource) {
        mCenter.setImageResource(resource);
    }

    private class HideRunnable implements Runnable {
        @Override
        public void run() {
            CustomProgressBar.this.setVisibility(GONE);
        }
    }
}
