package com.jdcloud.media.demo.player.widget;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Environment;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.Toast;


import com.bumptech.glide.Glide;
import com.bumptech.glide.load.engine.DiskCacheStrategy;
import com.bumptech.glide.request.RequestOptions;
import com.jdcloud.media.demo.DemoApplication;
import com.jdcloud.media.demo.R;
import com.jdcloud.media.demo.common.Constant;
import com.jdcloud.media.demo.player.BasePlayerActivity;
import com.jdcloud.media.demo.player.bean.LocalVideo;
import com.jdcloud.media.demo.player.bean.Result;
import com.jdcloud.media.demo.player.bean.Stream;
import com.jdcloud.media.demo.player.bean.VideoBean;
import com.jdcloud.media.demo.player.cotroller.JDCMediaController;
import com.jdcloud.media.demo.player.cotroller.JDCMediaControllerBase;
import com.jdcloud.media.demo.player.cotroller.JDCMediaControllerFull;
import com.jdcloud.media.demo.player.cotroller.MoreCallback;
import com.jdcloud.media.demo.utils.CommonUtils;
import com.jdcloud.media.demo.utils.LogUtil;
import com.jdcloud.media.demo.utils.SharePreferenceUtil;
import com.jdcloud.media.demo.utils.ToastUtil;
import com.jdcloud.media.player.jdcplayer.IMediaPlayer;
//import com.jdcloud.media.player.wrapper.JDCloudVideoCache;
//import com.jdcloud.media.player.wrapper.JDCloudVideoTool;
import com.jdcloud.media.player.wrapper.JDCloudVideoCache;
import com.jdcloud.media.player.wrapper.JDCloudVideoTool;
import com.jdcloud.media.player.wrapper.JDCloudVideoView;
import com.jdcloud.media.player.wrapper.PlayerConfig;
import com.jdcloud.media.player.wrapper.listener.SnapshotListener;
import com.jdcloud.media.player.wrapper.model.PlayerMonitor;
import com.jdcloud.media.player.wrapper.util.FFmpegCallback;
import com.jdcloud.media.player.wrapper.view.IRenderView;

import java.io.File;
import java.lang.reflect.Constructor;
import java.util.List;


public class JDPlayerView extends FrameLayout implements MoreCallback, SpeedView.SpeedCallback, StreamView.StreamCallback {
    private static final String TAG = "JDPlayerView";
    private Context mContext;
    private int mPlayMode = Constant.PLAYER.PLAY_MODE_NORMAL;
    private boolean mLockScreen = false;
    private boolean mIsMirror;
    // UI
    private ViewGroup mRootView;
    private RelativeLayout mVideoViewContent;
    private JDCloudVideoView mJDCloudVideoView;
    private JDCMediaController mNormalController;
    private JDCMediaControllerFull mFullScreenController;
    private ViewGroup.LayoutParams mNormalLayoutParams;
    private ViewGroup.LayoutParams mFullScreenLayoutParams;
    private LayoutParams mNormalControllerParams;
    private LayoutParams mFullScreenControllerParams;
    private LinearLayout mReturnNormalLL;
    private FrameLayout mReturnNormalFL;

    private int mPlayType;//如Constant.PLAYER.TYPE_LIVE
    private UpdateHandler mHandler;
    private PlayerViewCallback mPlayerViewCallback;
    public static int PLAY_STATE = Constant.PLAYER.IDLE;

    public String preVideoUrl;
    private VideoBean videoBean;

    private ImageView ivCover;

    /**
     * 在悬浮窗跳转来后，设置视频的信息
     *
     * @param bean     视频实体类
     * @param playType 视频类型
     */
    public void setVideoBean(VideoBean bean, int playType) {
        this.videoBean = bean;
        mPlayType = playType;
        //从悬浮窗跳转来后，启动时间和进度条更新
        mHandler.sendEmptyMessage(MSG_UPDATE);
        mNormalController.updateUI(videoBean, mPlayType);
        mFullScreenController.updateUI(videoBean, mPlayType);
        mNormalController.setDuration();
        mFullScreenController.setDuration();
    }

    public VideoBean getVideoBean() {
        return this.videoBean;
    }

    public JDPlayerView(Context context) {
        super(context);
        initView(context);
        initListener();
//        initPlayer();
    }

    public JDPlayerView(Context context, AttributeSet attrs) {
        super(context, attrs);
        initView(context);
        initListener();
//        initPlayer();
    }

    public JDPlayerView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        initView(context);
        initListener();
//        initPlayer();
    }

    private void initView(Context context) {
        mContext = context;
        mRootView = (ViewGroup) LayoutInflater.from(context).inflate(R.layout.layout_player_view, null);
        mVideoViewContent = mRootView.findViewById(R.id.cloud_video_view);
        mNormalController = mRootView.findViewById(R.id.controller_normal);
        mFullScreenController = mRootView.findViewById(R.id.controller_full_screen);
        mReturnNormalFL = mRootView.findViewById(R.id.fl_player_return_normal);
        mReturnNormalLL = mReturnNormalFL.findViewById(R.id.ll_player_return_normal);
        mNormalController.setController(mController);
        mFullScreenController.setController(mController);
        mFullScreenController.setCallBack(this);
        //设置倍速回调
        mFullScreenController.setSpeedCallback(this);
        mFullScreenController.setStreamCallback(this);
        mNormalControllerParams = new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
        mFullScreenControllerParams = new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
        removeAllViews();
        mRootView.removeView(mVideoViewContent);
        mRootView.removeView(mNormalController);
        mRootView.removeView(mFullScreenController);
        mRootView.removeView(mReturnNormalFL);
        addView(mVideoViewContent);
        if (mPlayMode == Constant.PLAYER.PLAY_MODE_NORMAL) {
            addView(mNormalController);
            mNormalController.hide();
        } else if (mPlayMode == Constant.PLAYER.PLAY_MODE_FULL) {
            addView(mFullScreenController);
            mFullScreenController.hide();
        }
        addView(mReturnNormalFL);
        post(new Runnable() {
            @Override
            public void run() {
                if (mPlayMode == Constant.PLAYER.PLAY_MODE_NORMAL) {
                    mNormalLayoutParams = getLayoutParams();
                }
                try {
                    // 依据上层Parent的LayoutParam类型来实例化一个新的fullscreen模式下的LayoutParam
                    Class parentLayoutParamClazz = getLayoutParams().getClass();
                    Constructor constructor = parentLayoutParamClazz.getDeclaredConstructor(int.class, int.class);
                    mFullScreenLayoutParams = (android.view.ViewGroup.LayoutParams) constructor.newInstance(android.view.ViewGroup.LayoutParams.MATCH_PARENT, android.view.ViewGroup.LayoutParams.MATCH_PARENT);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }

    private void initListener() {
        mReturnNormalLL.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                mJDCloudVideoView.setVisibility(View.VISIBLE);
                mReturnNormalFL.setVisibility(View.GONE);
            }
        });
        mHandler = new UpdateHandler();
    }

    public void addVideoView(JDCloudVideoView videoView) {
        if (videoView != null) {
            mJDCloudVideoView = videoView;
            //设置native日志等级，方便筛选
            PlayerConfig config = new PlayerConfig();
            config.setNativeLogLevel(PlayerConfig.LOG_ERROR);
            config.setEnableBackgroud(false);
            mJDCloudVideoView.setPlayerConfig(config);
            //默认显示模式是填充
            mJDCloudVideoView.setScalingMode(IRenderView.SCALING_MODE_ASPECT_FIT);
            mVideoViewContent.addView(videoView);


            //添加封面
            if (ivCover == null) {
                ivCover = new ImageView(mContext);
                ivCover.setLayoutParams(new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
            }
            if (ivCover.getParent() != null) {
                ((RelativeLayout) ivCover.getParent()).removeView(ivCover);
            }
//            mVideoViewContent.addView(ivCover);
            mJDCloudVideoView.setCoverView(ivCover);
        }
    }

    public void play(VideoBean vb, boolean isFirstPlay, int type) {
        //设置封面
//        Glide.with(mContext).load(vb.getHolderImage()).into(ivCover);
        if (ivCover != null) {
            if (vb instanceof LocalVideo) {
                RequestOptions options = new RequestOptions();
                options.diskCacheStrategy(DiskCacheStrategy.NONE);
                Glide.with(mContext).load(new File(((LocalVideo) vb).getPath())).apply(options).into(ivCover);
            } else if (vb instanceof Result) {
                Glide.with(mContext).load(((Result) vb).getImgUrl()).into(ivCover);
            }
        }

        PLAY_STATE = Constant.PLAYER.IDLE;
        updatePlayStatus(true);

        mPlayType = type;
        if (this.videoBean != null) {
            //保存地址以便停止缓存
            preVideoUrl = this.videoBean.getVideoURL();
        }
        this.videoBean = vb;
        mNormalController.updateUI(vb, mPlayType);
        mFullScreenController.updateUI(vb, mPlayType);

        if (vb instanceof Result) {
            //有清晰度列表，先初始化列表
            setStreamList(((Result) vb).getStreamList());
        } else {
            //非网络数据，只有一个清晰度
            setStreamList(null);
        }
        if (mJDCloudVideoView != null) {
            if (isFirstPlay) {
                if (mPlayType == Constant.PLAYER.TYPE_VOD) {
                    //点播set 边播放边下载
                    JDCloudVideoCache cache = DemoApplication.getCache();
                    if (!TextUtils.isEmpty(preVideoUrl)) {
                        cache.shutdownClient(cache.getProxyUrl(preVideoUrl));
                    }
                    String proxyUrl = cache.getProxyUrl(vb.getVideoURL());
//                     LogUtil.d("BLAY", "视频url：" + proxyUrl);
                    mJDCloudVideoView.setVideoPath(proxyUrl);
                    //提前缓存下一个视频
                    VideoBean bean = ((BasePlayerActivity) mContext).getNextVideo();
                    if (bean != null) {
                        DemoApplication.getCache().preDownload(bean.getVideoURL());
                    }
                } else {//直播，本地，url播放
                    LogUtil.d("BLAY", "视频url：" + vb.getVideoURL());
                    mJDCloudVideoView.setVideoPath(vb.getVideoURL());
                }
                mJDCloudVideoView.start();
            } else {
                if (mPlayType == Constant.PLAYER.TYPE_VOD) {
                    //点播set 边播放边下载
                    JDCloudVideoCache cache = DemoApplication.getCache();
                    if (!TextUtils.isEmpty(preVideoUrl)) {
                        cache.shutdownClient(cache.getProxyUrl(preVideoUrl));
                    }
                    String proxyUrl = cache.getProxyUrl(vb.getVideoURL());
//                    LogUtil.d("BLAY", "视频url：" + proxyUrl);
                    mJDCloudVideoView.switchDataSource(proxyUrl);
                    VideoBean bean = ((BasePlayerActivity) mContext).getNextVideo();
                    if (bean != null) {
                        DemoApplication.getCache().preDownload(bean.getVideoURL());
                    }
                } else {//直播，本地，url播放
                    LogUtil.d("BLAY", "视频url：" + vb.getVideoURL());
                    mJDCloudVideoView.switchDataSource(vb.getVideoURL());
                }
                //   switchDataSource会自动启动播放
            }
        }
        //切换视频时候，重置镜像为false，解决切换切换有角度和没有角度的视频时候，有时候会倒置的问题。
        mJDCloudVideoView.setMirror(false);
        mIsMirror = false;

    }

    public void onResume() {
//        LogUtil.i("BLAY","JDPlayerView-onResume：mPlayMode【normal|full|float--1001,1002,1003】"+mPlayMode);
        if (PLAY_STATE == Constant.PLAYER.STARTED && videoBean != null) {
            mJDCloudVideoView.start();
        }
    }

    /**
     * @param temporary 临时暂停不需要把图标设置为暂停状态
     */
    public void onPause(Boolean temporary) {
        mJDCloudVideoView.pause();
        if (!temporary) {
            PLAY_STATE = Constant.PLAYER.PAUSED;
            updatePlayStatus(true);
        }
    }

    /**
     * @param justLoading 是否仅仅更新进度条
     *                    false 除了更新进度条还需要更新界面元素
     *                    <p>
     *                    更新播放状态
     */
    public void updatePlayStatus(boolean justLoading) {
//        PLAY_STATE = status;
        mNormalController.updatePlayState();
        mFullScreenController.updatePlayState();
        if (justLoading) {
            return;
        }
//        SharePreferenceUtil.getInstance().setIsPlaying(status == Constant.PLAYER.STATE_PLAYING);
        if (PLAY_STATE == Constant.PLAYER.PREPARED) {
            //启动进度条和计时
            mHandler.sendEmptyMessage(MSG_UPDATE);
            if (mJDCloudVideoView.getDuration() > 0) {
                videoBean.setTime(mJDCloudVideoView.getDuration());
//                LogUtil.d("BLAY", "播放视频信息：总长：" + videoBean.getTime() + ",播放类型" + type + "【VOD|LIVE|LOCAL=2001|2002|2003】，title："+vb.getName());
            } else {
//                LogUtil.d("BLAY", "播放视频信息：未获取到视频总长：" + ",播放类型" + type + "【VOD|LIVE|LOCAL=2001|2002|2003】，title："+vb.getName());
            }
            mNormalController.setDuration();
            mFullScreenController.setDuration();
        } else if (PLAY_STATE == Constant.PLAYER.COMPLETED) {
            //直播播放完成给出提示
            if (mPlayType == Constant.PLAYER.TYPE_LIVE) {
                ToastUtil.makeText(getContext(), "直播结束~", Toast.LENGTH_SHORT);
            } else if (mPlayType == Constant.PLAYER.TYPE_URL) {
                if (mJDCloudVideoView.getDuration() == 0) {//扫码直播
                    ToastUtil.makeText(getContext(), "直播结束~", Toast.LENGTH_SHORT);
                }
            }
        }
    }

    public void setPlayerViewCallback(PlayerViewCallback callback) {
        mPlayerViewCallback = callback;
    }

    private JDCMediaControllerBase.BaseController mController = new JDCMediaControllerBase.BaseController() {

        @Override
        public int getPlayType() {
            return mPlayType;
        }

        @Override
        public void onRequestPlayMode(int requestPlayMode) {
            if (mPlayMode == requestPlayMode)
                return;
            if (mLockScreen)
                return;
            mNormalController.hide();
            mFullScreenController.hide();
            removeView(mReturnNormalFL);
            if (requestPlayMode == Constant.PLAYER.PLAY_MODE_FULL) {
                if (mFullScreenLayoutParams == null)
                    return;
                removeView(mNormalController);
                addView(mFullScreenController, mFullScreenControllerParams);
                handleAudioOnlyReturn();
                setLayoutParams(mFullScreenLayoutParams);
                rotateScreenOrientation(Constant.PLAYER.SCREEN_LAND);
                if (mPlayerViewCallback != null) {
                    mPlayerViewCallback.hideViews();
                }
//                ((BasePlayerActivity) mContext).hideMoreView();//防止用户点击了更多后点击横屏
            } else if (requestPlayMode == Constant.PLAYER.PLAY_MODE_NORMAL) {
                if (mPlayMode == Constant.PLAYER.PLAY_MODE_FULL) {
                    if (mNormalLayoutParams == null)
                        return;
                    removeView(mFullScreenController);
                }
                addView(mNormalController, mNormalControllerParams);
                handleAudioOnlyReturn();
                setLayoutParams(mNormalLayoutParams);
                rotateScreenOrientation(Constant.PLAYER.SCREEN_PORT);
                if (mPlayerViewCallback != null) {
                    mPlayerViewCallback.showViews();
                }
            }
            LogUtil.d(TAG, "play mode is " + requestPlayMode);
            mPlayMode = requestPlayMode;
        }

        @Override
        public void onBackPressed(int playMode) {
            if (playMode == Constant.PLAYER.PLAY_MODE_FULL) {
                onRequestPlayMode(Constant.PLAYER.PLAY_MODE_NORMAL);
            }
        }

        @Override
        public void start() {
            if (mPlayMode == Constant.PLAYER.PLAY_MODE_FULL && mFullScreenController.isLoading()) {
                ToastUtil.makeText(mContext, "正在加载，请稍后再试", Toast.LENGTH_SHORT);
                return;
            }
            //如果视频播放到末尾，会从头开始播放(start方法是同步的)
            mJDCloudVideoView.start();
            if (PLAY_STATE != Constant.PLAYER.STARTED) {
                PLAY_STATE = Constant.PLAYER.STARTED;
            }
            //启动进度条和时间显示循环
            mHandler.sendEmptyMessage(MSG_UPDATE);
        }

        @Override
        public void pause() {
            mJDCloudVideoView.pause();
            PLAY_STATE = Constant.PLAYER.PAUSED;
        }

        @Override
        public long getDuration() {
            if (videoBean == null) {
                return 0;
            }
            if (mJDCloudVideoView != null && mPlayType != Constant.PLAYER.TYPE_LIVE) {
                return mJDCloudVideoView.getDuration();
            } else return 0;
        }

        @Override
        public int getCurrentPlayTime() {
            if (mJDCloudVideoView != null) {
                return mJDCloudVideoView.getCurrentPosition();
            } else return 0;
        }

        @Override
        public void seekTo(int position) {
            if (mJDCloudVideoView != null) {
//                updatePlayStatus(Constant.PLAYER.STATE_PAUSED);
                mJDCloudVideoView.seekTo(position);
            }
            PLAY_STATE = Constant.PLAYER.SEEKING;
            updatePlayStatus(true);
        }

        @Override
        public boolean isPlaying() {
            if (mJDCloudVideoView != null) {
                if (PLAY_STATE == Constant.PLAYER.IDLE) {
                    return false;
                }
                if (PLAY_STATE == Constant.PLAYER.SEEKING) {
                    return false;
                }
//                LogUtil.e("BLAY","mJDCloudVideoView.isPlaying()----------"+mJDCloudVideoView.isPlaying()+","+PLAY_STATE);
                return mJDCloudVideoView.isPlaying();
            }
//            LogUtil.e("BLAY","mJDCloudVideoView == null;mJDCloudVideoView.isPlaying()----------"+mJDCloudVideoView.isPlaying());
            return false;
        }

        @Override
        public void onCutScreen() {
            showSnapshotWindow(mJDCloudVideoView.takeSnapShot());
        }

        @Override
        public void onGIFPress() {
            if (mFullScreenController.isLoading()) {
                ToastUtil.makeText(mContext, "正在加载，请稍后再试", Toast.LENGTH_SHORT);
                return;
            }
            //先暂停播放，再进行gif截屏处理
            if (isPlaying()) {
                pause();
            } else {
                LogUtil.d("BLAY", "视频暂停状态，无需pause");
            }
            //截取的小视频，起始时间是当前时间的前后5s
            final int currentSecond = mJDCloudVideoView.getCurrentPosition() / 1000;

            String path = CommonUtils.getGifVideo(mContext);
            File appDir = new File(path);
//            if (appDir.exists() && appDir.listFiles().length > 0) {
//                LogUtil.d("BLAY", "delete all files of jdcplayer/video");
//                //每次都删除以前保存的文件
//                CommonUtils.delFolder(path);
//            }
            if (!appDir.exists()) {
                if (!appDir.mkdirs()) {
//                    ToastUtil.makeText(mContext, "临时目录创建失败", Toast.LENGTH_SHORT);
                    LogUtil.d("BLAY", "**************" + appDir.getPath() + "创建失败");
                    return;
                }
            }
            int startT = 0, endT = 10;
            int duration = mJDCloudVideoView.getDuration() / 1000;
            if (duration <= 10) {
                endT = duration;
            } else if (currentSecond < 5) {
                //使用默认值
            } else if (duration <= currentSecond + 5) {
                endT = duration;
                startT = endT - 10;
            } else {
                startT = currentSecond - 5;
                endT = currentSecond + 5;
            }
            mFullScreenController.showProgressBar();
            LogUtil.d("BLAY", "******************currentSecond|duration:" + currentSecond + "," + duration + ",startT：" + startT + ",endT:" + endT + ",path:" + appDir.getPath());
            JDCloudVideoTool.recordVideo(JDPlayerView.this.videoBean.getVideoURL(), appDir.getPath(), 320, 15, startT, endT, new FFmpegCallback() {
                @Override
                public void onStart() {
                    LogUtil.d("BLAY", "recordVideo:onStart*********" + "videoUrl:" + JDPlayerView.this.videoBean.getVideoURL());
                }
                @Override
                public void onProgress(float v, int i) {
                    LogUtil.d("BLAY", "recordVideo:onProgress*********"+v+","+i);
                }

                @Override
                public void onCompletion(int i) {
                    LogUtil.d("BLAY", "recordVideo:onCompletion*********i="+i);
                    Message msg = Message.obtain();
                    if(i==0){//成功
                        msg.what = MSG_GIF_RECORDVIDEO_CORRECT;
//                        msg.arg1 = currentSecond;
                        mHandler.sendMessage(msg);
                    }else if(i==-1){//取消
                        msg.what = MSG_GIF_RECORDVIDEO_ERROR;
                        msg.arg1=-1;
                        mHandler.sendMessage(msg);
                    }
                }
            });
        }

        @Override
        public void onNextVideo() {
            if (mFullScreenController.isLoading()) {
                ToastUtil.makeText(mContext, "正在加载，请稍后再试", Toast.LENGTH_SHORT);
                return;
            }
            ((BasePlayerActivity) mContext).playNextVideo();
        }

        @Override
        public boolean isMirror() {
            return mIsMirror;
        }

        @Override
        public void onQualitySelected(Stream quality) {
            //选清晰度后的回调
            mFullScreenController.updateQualityText(quality.getName());
            if (mJDCloudVideoView != null) {
                mJDCloudVideoView.pause();
                if (mPlayType == Constant.PLAYER.TYPE_VOD) {//点播,目前格式只有一种MP4格式，可以边播边下载
                    if (quality.getPlayUrl() != null) {
                        JDCloudVideoCache cache = DemoApplication.getCache();
                        if (!TextUtils.isEmpty(preVideoUrl)) {
                            cache.shutdownClient(cache.getProxyUrl(preVideoUrl));
                        }
                        String proxyUrl = cache.getProxyUrl(quality.getPlayUrl());
                        mJDCloudVideoView.setVideoPath(proxyUrl);
                        JDPlayerView.this.videoBean.setVideoURL(quality.getPlayUrl());
                        VideoBean bean = ((BasePlayerActivity) mContext).getNextVideo();
                        if (bean != null) {
                            DemoApplication.getCache().preDownload(bean.getVideoURL());
                        }
                    } else {
                        ToastUtil.makeText(mContext, "播放地址为空", Toast.LENGTH_SHORT);
                    }
                } else {//直播，取rtmp的播放，没有缓存功能
//                    if (quality.getPlayUrlRtmp() != null) {
                    String url = quality.getPlayUrlRtmp();
//                    String url=quality.getPlayUrlM3u8();
                    if (url != null) {
                        mJDCloudVideoView.setVideoPath(url);
                        JDPlayerView.this.videoBean.setVideoURL(url);
                    } else {
                        ToastUtil.makeText(mContext, "播放地址为空", Toast.LENGTH_SHORT);
                    }
                }
                LogUtil.d("BLAY", "onQualitySelected:播放视频的url------" + JDPlayerView.this.videoBean.getVideoURL());
                mJDCloudVideoView.seekTo(getCurrentPlayTime());
                mJDCloudVideoView.start();
            }
        }

        @Override
        public void onSpeedChanged(float speedLevel) {
            //设置倍速大小
            if (mJDCloudVideoView != null && mPlayType != Constant.PLAYER.TYPE_LIVE) {
                mJDCloudVideoView.setSpeed(speedLevel);
                mFullScreenController.setSpeedText(speedLevel + "");
            }
        }


        @Override
        public void onReplay() {
        }

        @Override
        public boolean isBackgroundPlay() {
            return mJDCloudVideoView.isBackgroundPlayEnabled();
        }

        @Override
        public void showMoreView() {
            ((BasePlayerActivity) mContext).showMoreView();
        }
    };

    private void handleAudioOnlyReturn() {
        removeView(mReturnNormalFL);
        addView(mReturnNormalFL);
        initListener();
    }

    private void showSnapshotWindow(final Bitmap bmp) {
        ToastUtil.getToast().makeFullToast(mContext, null, 3000);
        ToastUtil.getToast().setImageBitmap(bmp);
        ToastUtil.getToast().showToast();
        AsyncTask.execute(new Runnable() {
            @Override
            public void run() {
                CommonUtils.saveImage(mContext, bmp);
            }
        });
    }

    private void rotateScreenOrientation(int orientation) {
        switch (orientation) {
            case Constant.PLAYER.SCREEN_LAND:
                ((Activity) mContext).setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
                break;
            case Constant.PLAYER.SCREEN_PORT:
                ((Activity) mContext).setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
                break;
            default:
                break;
        }
    }

    private void requestPlayMode(int playMode) {
        if (mPlayMode == playMode) {
            return;
        }
//        if (playMode == Constant.PLAYER.PLAY_MODE_NORMAL) {
        if (mController != null) {
            mController.onRequestPlayMode(Constant.PLAYER.PLAY_MODE_NORMAL);
//            }
        }
    }

    public int getPlayMode() {
        return mPlayMode;
    }
//    public void setPlayMode(int playMode){
//        mPlayMode=playMode;
//    }

    @Override
    public void mirrorPlay(boolean mirror) {
        if (mJDCloudVideoView != null) {
            //设置镜像播放
            mJDCloudVideoView.setMirror(mirror);
        }
        mIsMirror = mirror;
    }

    @Override
    public void backgroundPlay(boolean background) {
//        mIsBackgroundPlay = background;
        if (mJDCloudVideoView != null) {
//            mJDCloudVideoView.enterBackground();
            mJDCloudVideoView.setBackgroundPlay(background);
        }
    }

    public boolean getIsBackgroundPlay() {
        return mJDCloudVideoView.isBackgroundPlayEnabled();
    }

    @Override
    public void audioOnlyPlay() {
        if (mJDCloudVideoView != null) {
            mJDCloudVideoView.setVisibility(View.INVISIBLE);
            mReturnNormalFL.setVisibility(View.VISIBLE);
        }
    }

    @Override
    public void checkDoc() {

    }

    @Override
    public void outSubtitle() {

    }

    @Override
    public void scaleMode(int mode) {
        if (mJDCloudVideoView != null) {
            mJDCloudVideoView.setScalingMode(mode);
        }
    }

    public void setStreamList(List<Stream> list) {
//        videoBean.setVideoURL(list.get(0).getPlayUrlRtmp());
        if (mFullScreenController != null) {
            mFullScreenController.setVideoQualityList(list);
            if (list != null && list.size() > 0) {
                mController.onQualitySelected(list.get(0));
            }
        }
    }

    public boolean getIsMirror() {
        return mIsMirror;
    }

    @Override
    public void speedMode(float speed) {
        mController.onSpeedChanged(speed);
    }

    @Override
    public void updateStream(Stream stream) {
        mController.onQualitySelected(stream);
    }

    public interface PlayerViewCallback {

        void hideViews();

        void showViews();

//        void onQuit(int playMode);
    }

    private static final int MSG_UPDATE = 1001;
    private static final int MSG_RESET = 1002;
    private static final int MSG_GIF_RECORDVIDEO_CORRECT = 1000;
    private static final int MSG_GIF_RECORDVIDEO_ERROR = 999;
//    private ProgressBar progressBar;

    public class UpdateHandler extends Handler {

        @Override
        public void handleMessage(Message msg) {

            switch (msg.what) {
                case MSG_UPDATE:
//                    LogUtil.i("BLAY", "current:duration***********" + mController.getCurrentPlayTime()+","+mController.getDuration());
//                    LogUtil.i("BLAY", "mCurrentPlayState:" +mCurrentPlayState+"【STATE_PLAYING，3004】【STATE_PAUSED，3005】【STATE_COMPLETED ，3008】");
                    if (PLAY_STATE == Constant.PLAYER.COMPLETED) {
//                        mHandler.removeCallbacksAndMessages(null);
                        mNormalController.updateVideoProgress(mPlayType, mController.getDuration());
                        mFullScreenController.updateVideoProgress(mPlayType, mController.getDuration());
                    } else {
                        mNormalController.updateVideoProgress(mPlayType, mController.getCurrentPlayTime());
                        mFullScreenController.updateVideoProgress(mPlayType, mController.getCurrentPlayTime());
                        mHandler.sendEmptyMessageDelayed(MSG_UPDATE, 1000);
                    }
                    break;
                case MSG_GIF_RECORDVIDEO_CORRECT:
//                    录制完成，展示gif界面
                    mFullScreenController.showGifLayout();
                    String path = CommonUtils.getGifVideo(mContext) + "/output.mp4";
                    File file = new File(path);
                    Intent mediaScanIntent = new Intent(
                            "android.intent.action.MEDIA_SCANNER_SCAN_FILE");
                    Uri contentUri = Uri.fromFile(file);
                    mediaScanIntent.setData(contentUri);
                    mContext.getApplicationContext().sendBroadcast(mediaScanIntent);
                    break;
                case MSG_RESET:
                    PLAY_STATE = Constant.PLAYER.IDLE;
                    mNormalController.updateVideoProgress(mPlayType, 0);
                    mFullScreenController.updateVideoProgress(mPlayType, 0);
                    mJDCloudVideoView.seekTo(0);
                    ToastUtil.makeText(mContext, "MSG_RESET", Toast.LENGTH_SHORT);
                    break;
                case MSG_GIF_RECORDVIDEO_ERROR:
                    if (msg.arg1 == -1) {
//                        ToastUtil.makeText(mContext,"录屏出现错误，请稍后再试",Toast.LENGTH_SHORT);
                    } else {
                        ToastUtil.makeText(mContext, "录屏出现错误，请稍后再试", Toast.LENGTH_SHORT);
                    }
                    String path1 = CommonUtils.getGifVideo(mContext);
                    final File appDir1 = new File(path1, "output.mp4");
                    if (appDir1.exists()) {
                        appDir1.delete();
                        LogUtil.d("BLAY", "delete file output.mp4");
                    }
                    mFullScreenController.toControllerFull(false);
                    break;
                default:
                    break;
            }
        }
    }

    public void pauseGifPlayer() {
        if (mPlayMode == Constant.PLAYER.PLAY_MODE_FULL) {
            mFullScreenController.pause();
        }
    }

    public void onBackPressed() {
        if (!mFullScreenController.onBackPressed()) {
            requestPlayMode(Constant.PLAYER.PLAY_MODE_NORMAL);
        }
    }

    public PlayerMonitor getPlayerMonitor() {
        return mJDCloudVideoView.getPlayMonitor();
    }
}
