package com.jdcloud.media.demo.player.widget;

import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.widget.LinearLayout;

import com.jdcloud.media.demo.R;
import com.jdcloud.media.demo.common.view.ToggleButton;
import com.jdcloud.media.demo.player.cotroller.MoreCallback;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class MoreView extends LinearLayout implements ToggleButton.OnToggleChangedListener {
    private Context mContext;

    @BindView(R.id.tb_mirror_play)
    ToggleButton mMirrorPlayTB;
    @BindView(R.id.tb_background_play)
    ToggleButton mBackgroundPlayTB;

    private MoreCallback mMoreCallBack;

    public void setCallBack(MoreCallback callBack) {
        this.mMoreCallBack = callBack;
    }

    public MoreView(Context context) {
        super(context);
        init(context);
    }

    public MoreView(Context context, AttributeSet attrs) {
        super(context, attrs);
        init(context);
    }

    public MoreView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init(context);
    }

    private void init(Context context) {
        mContext = context;
        LayoutInflater.from(mContext).inflate(R.layout.layout_pop_player_more, this);
        ButterKnife.bind(this);
        mMirrorPlayTB.setOnToggleChanged(this);
        mBackgroundPlayTB.setOnToggleChanged(this);
    }

    @OnClick(R.id.ll_player_check_doc)
    public void checkDoc() {
        mMoreCallBack.checkDoc();
    }

    @OnClick(R.id.ll_player_audio_only)
    public void audioOnly() {
        mMoreCallBack.audioOnlyPlay();
    }

    @OnClick(R.id.ll_player_out_subtitle)
    public void outSubtitle() {
        mMoreCallBack.outSubtitle();
    }

    @Override
    public void onToggle(boolean on, int id) {
//        if(mMoreCallBack==null){
//            return;
//        }
        switch (id) {
            case R.id.tb_mirror_play:
                mMoreCallBack.mirrorPlay(on);
                break;
            case R.id.tb_background_play:
                mMoreCallBack.backgroundPlay(on);
                break;
            default:
                break;
        }
    }

    public void initBackgroundUi(boolean isBack) {
        if (isBack) {
            mBackgroundPlayTB.setToggleOn();
        } else {
            mBackgroundPlayTB.setToggleOff();
        }
    }

    public void updateMirrorUi(boolean isMirror) {
        if (isMirror) {
            mMirrorPlayTB.setToggleOn();
        } else {
            mMirrorPlayTB.setToggleOff();
        }
    }
}
