package com.jdcloud.media.demo.player.widget;

import android.content.Context;
import android.support.annotation.Nullable;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.widget.LinearLayout;
import android.widget.RadioGroup;

import com.jdcloud.media.demo.R;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * 倍速选择view
 */
public class SpeedView extends LinearLayout {
    @BindView(R.id.speed_mode_pattern)
    RadioGroup mSpeedRG;
    private SpeedCallback mCallback;

    public void setCallback(SpeedCallback callback) {
        this.mCallback = callback;
    }

    public SpeedView(Context context) {
        super(context);
        init(context);
    }

    public SpeedView(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        init(context);
    }

    public SpeedView(Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init(context);
    }

    private void init(Context context) {
        LayoutInflater.from(context).inflate(R.layout.layout_pop_player_speed, this);
        ButterKnife.bind(this);
        mSpeedRG.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (checkedId) {
                    case R.id.speed_2:
                        mCallback.speedMode(2.0f);
                        break;
                    case R.id.speed_1_5:
                        mCallback.speedMode(1.5f);
                        break;
                    case R.id.speed_1_25:
                        mCallback.speedMode(1.25f);
                        break;
                    case R.id.speed_0_75:
                        mCallback.speedMode(0.75f);
                        break;
                    case R.id.speed_0_5:
                        mCallback.speedMode(0.5f);
                        break;
                    default:
                    case R.id.speed_1:
                        mCallback.speedMode(1.0f);
                        break;
                }
            }
        });
    }

    public void reset(){
        mSpeedRG.check(R.id.speed_1);
    }
    public interface SpeedCallback {
        void speedMode(float speed);
    }

}
