package com.jdcloud.media.demo.player.widget;

import android.content.Context;
import android.os.Looper;
import android.support.annotation.Nullable;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.jdcloud.media.demo.R;
import com.jdcloud.media.demo.player.bean.Stream;
import com.jdcloud.media.demo.utils.LogUtil;
import com.jdcloud.media.demo.utils.ToastUtil;

import java.util.List;
import java.util.logging.Handler;

import butterknife.BindView;
import butterknife.ButterKnife;

public class StreamView extends LinearLayout {

    @BindView(R.id.tv_stream_lc)
    TextView tv_stream_lc;
    @BindView(R.id.tv_stream_sd)
    TextView tvStreamSD;
    @BindView(R.id.tv_stream_hd)
    TextView tvStreamHD;
    @BindView(R.id.tv_stream_fhd)
    TextView tvStreamFHD;

//    private Stream mSDStream, mHDStream, mFHDStream;
    private Context mContext;
    private StreamListener mListener;
    private StreamCallback mCallback;

    protected List<Stream> mVideoQualityList;
    public StreamView(Context context) {
        super(context);
        init(context);
    }

    public void setCallback(StreamCallback callback) {
        this.mCallback = callback;
    }

    public StreamView(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        init(context);
    }

    public StreamView(Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init(context);
    }

    private void init(Context context) {
        mContext = context;
        mListener = new StreamListener();
        LayoutInflater.from(context).inflate(R.layout.layout_pop_player_stream, this);
        ButterKnife.bind(this);
        tv_stream_lc.setOnClickListener(mListener);
        tvStreamHD.setOnClickListener(mListener);
        tvStreamFHD.setOnClickListener(mListener);
        tvStreamSD.setOnClickListener(mListener);
    }

    public void setStreamList(List<Stream> list) {
        tvStreamSD.setVisibility(GONE);
        tv_stream_lc.setVisibility(GONE);
        tvStreamHD.setVisibility(GONE);
        tvStreamFHD.setVisibility(GONE);
        mVideoQualityList=list;

        if (list != null) {
            for (Stream s : list) {
                if(s.getName().equals("流畅")){
                    tv_stream_lc.setVisibility(VISIBLE);
                }
                if(s.getName().equals("标清")){
                    tvStreamSD.setVisibility(VISIBLE);
                }
                if(s.getName().equals("高清")){
                    tvStreamHD.setVisibility(VISIBLE);
                }
                if(s.getName().equals("超清")){
                    tvStreamFHD.setVisibility(VISIBLE);
                }
            }
            String firstName=list.get(0).getName();

            tv_stream_lc.setSelected(false);
            tvStreamSD.setSelected(false);
            tvStreamHD.setSelected(false);
            tvStreamFHD.setSelected(false);
            if("流畅".equals(firstName)){
                tv_stream_lc.setSelected(true);
            }else if("标清".equals(firstName)){
                tvStreamSD.setSelected(true);
            }else if("高清".equals(firstName)){
                tvStreamHD.setSelected(true);
            }else if("超清".equals(firstName)){
                tvStreamFHD.setSelected(true);
            }
        }
    }

    class StreamListener implements View.OnClickListener {
        @Override
        public void onClick(View v) {
            if(v.isSelected()){
                setVisibility(GONE);
                return;
            }
//            updateUi(v);
            tvStreamSD.setSelected(false);
            tv_stream_lc.setSelected(false);
            tvStreamHD.setSelected(false);
            tvStreamFHD.setSelected(false);
            if(mVideoQualityList==null){
                ToastUtil.makeText(getContext(),"列表为空",Toast.LENGTH_SHORT);
                setVisibility(GONE);
                return;
            }
            for (Stream s : mVideoQualityList) {
                if(((TextView)v).getText().equals(s.getName())){
                    mCallback.updateStream(s);
                    v.setSelected(true);
                    LogUtil.e("BLAY","切换为"+s.getName()+((TextView)v).isSelected());
                }
//                initStream(s);
            }
            setVisibility(GONE);
         }
    }

//    private void updateUi(View v) {
//        if (v == tvStreamSD) {
//            tvStreamSD.setSelected(true);
//            mStreamHD.setSelected(false);
//            mStreamFHD.setSelected(false);
//        } else if (v == mStreamHD) {
//            mStreamSD.setSelected(false);
//            mStreamHD.setSelected(true);
//            mStreamFHD.setSelected(false);
//        } else if (v == mStreamFHD) {
//            mStreamSD.setSelected(false);
//            mStreamHD.setSelected(false);
//            mStreamFHD.setSelected(true);
//        }
//        setVisibility(GONE);
//    }

//    public void initDefaultStream(Stream stream) {
//
//        tvStreamSD.setSelected(false);
//        tv_stream_lc.setSelected(false);
//        tvStreamHD.setSelected(false);
//        tvStreamFHD.setSelected(false);
//        for (Stream s : mVideoQualityList) {
//            if(((TextView)v).getText().equals(s.getName())){
//                ((TextView)v).setSelected(true);
//                mCallback.updateStream(s);
//            }
//            initStream(s);
//        }
//
//
//
//
//        if (stream.getName().equals(mContext.getString(R.string.player_stream_sd))) {
//            //标清
//            mStreamSD.setVisibility(View.VISIBLE);
//            updateUi(mStreamSD);
//            mSDStream = stream;
//        } else if (stream.getName().equals(mContext.getString(R.string.player_stream_hd))) {
//            mStreamHD.setVisibility(View.VISIBLE);
//            updateUi(mStreamHD);
//            mHDStream = stream;
//        } else if (stream.getName().equals(mContext.getString(R.string.player_stream_fhd))) {
//            mStreamFHD.setVisibility(View.VISIBLE);
//            updateUi(mStreamFHD);
//            mFHDStream = stream;
//        }
//    }

//    private void initStream(Stream stream){
//        if (stream.getName().equals(mContext.getString(R.string.player_stream_sd))) {
//            tvStreamSD.setVisibility(View.VISIBLE);
////            mSDStream = stream;
//        } else if (stream.getName().equals(mContext.getString(R.string.player_stream_hd))) {
//            tvStreamHD.setVisibility(View.VISIBLE);
////            mHDStream = stream;
//        } else if (stream.getName().equals(mContext.getString(R.string.player_stream_fhd))) {
//            tvStreamFHD.setVisibility(View.VISIBLE);
////            mFHDStream = stream;
//        }else if(stream.getName().equals(mContext.getString(R.string.player_stream_lc))){
//            tv_stream_lc.setVisibility(View.VISIBLE);
//        }
//    }

    public interface StreamCallback {
        void updateStream(Stream stream);
    }
}
