package com.jdcloud.media.demo.push;

import com.jdcloud.media.live.JDCloudLive;

public enum PushUtil {
    /**
     * 单例实例
     */
    INSTANCE;

    private JDCloudLive mStreamer;
    private boolean mIsFloatViewShow;

    public JDCloudLive getStreamer() {
        return mStreamer;
    }

    public void setStreamer(JDCloudLive streamer) {
        destroyStreamer();
        this.mStreamer = streamer;
    }

    public void destroyStreamer() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                if (mStreamer != null) {
                    mStreamer.stopImageCapture();
                    mStreamer.stopCameraPreview();
                    mStreamer.stopBgm();
                    if (mStreamer.isPushing()) {
                        mStreamer.stopPush();
                        mStreamer.release();
                    }
                    mIsFloatViewShow = false;
                    mStreamer = null;
                }

            }
        }).start();
    }

    public boolean isPushIng() {
        if (mStreamer != null) {
            return mStreamer.isPushing();
        } else return false;
    }

    public boolean isFloatViewShow() {
        return mIsFloatViewShow;
    }

    public void setFloatViewShow(boolean show) {
        mIsFloatViewShow = show;
    }
}
