package com.jdcloud.media.demo.push.ui;

import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.hardware.Camera;
import android.hardware.SensorManager;
import android.media.AudioManager;
import android.net.Uri;
import android.opengl.GLSurfaceView;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.provider.MediaStore;
import android.util.Log;
import android.view.OrientationEventListener;
import android.view.Surface;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.Chronometer;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.jdcloud.media.demo.DemoApplication;
import com.jdcloud.media.demo.R;
import com.jdcloud.media.demo.base.BaseActivity;
import com.jdcloud.media.demo.common.Constant;
import com.jdcloud.media.demo.common.view.CameraView;
import com.jdcloud.media.demo.common.view.CustomDialog;
import com.jdcloud.media.demo.common.view.ToggleButton;
import com.jdcloud.media.demo.common.view.WaterMarkEditView;
import com.jdcloud.media.demo.push.PushUtil;
import com.jdcloud.media.demo.push.config.BaseConfig;
import com.jdcloud.media.demo.push.config.SeniorConfig;
import com.jdcloud.media.demo.utils.ActivityUtil;
import com.jdcloud.media.demo.utils.CommonUtils;
import com.jdcloud.media.demo.utils.LogUtil;
import com.jdcloud.media.demo.utils.SharePreferenceUtil;
import com.jdcloud.media.demo.utils.ToastUtil;
import com.jdcloud.media.live.JDCloudLive;
//import com.jdcloud.media.live.JDCloudPIPLive;
import com.jdcloud.media.live.base.opengl.GLRender;
import com.jdcloud.media.live.capture.CameraCapture;
import com.jdcloud.media.live.capture.ViewCapture;
import com.jdcloud.media.live.capture.camera.CameraTouch;
import com.jdcloud.media.live.coder.encoder.VideoEncodeFormat;
import com.jdcloud.media.live.config.BaseConstants;
import com.jdcloud.media.live.filter.audio.AudioEffectFilter;
import com.jdcloud.media.live.filter.audio.AudioFilterBase;
import com.jdcloud.media.live.filter.beauty.imgtex.ImgBeautyProFilter;
import com.jdcloud.media.live.filter.beauty.imgtex.ImgBeautySpecialEffectsFilter;
import com.jdcloud.media.live.filter.beauty.imgtex.ImgFilterBase;
import com.jdcloud.media.live.listener.ErrorListener;
import com.jdcloud.media.live.listener.InfoListener;
import com.jdcloud.media.live.util.BitmapUtil;
import com.jdcloud.media.player.jdcplayer.IMediaPlayer;
import com.lht.paintview.PaintView;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;


public class PushActivity extends BaseActivity implements ToggleButton.OnToggleChangedListener {
    private static final String TAG = PushActivity.class.getSimpleName();

    @BindView(R.id.chm_live)
    Chronometer mCHMLive;
    @BindView(R.id.gl_live_push)
    GLSurfaceView mGLSurface;
    @BindView(R.id.tv_live_push_cmd)
    TextView mPushText;
    @BindView(R.id.iv_live_push_cmd)
    ImageView mPushImage;
    @BindView(R.id.iv_red_point)
    ImageView mRedPoint;
    @BindView(R.id.fl_push_container)
    FrameLayout mContainer;
    @BindView(R.id.fl_live_beauty_level)
    FrameLayout mLiveBeauty;
    @BindView(R.id.live_base_push)
    RelativeLayout mBasePushView;
    @BindView(R.id.iv_live_push_voice)
    ImageView mMuteView;
    @BindView(R.id.fl_live_more)
    FrameLayout mLiveMore;
    @BindView(R.id.ll_audio_only_push_return)
    LinearLayout mLLAudioOnlyPushView;
    @BindView(R.id.fl_live_water_mark)
    FrameLayout mWaterMarkPop;
    @BindView(R.id.wme_center)
    WaterMarkEditView mWaterMarkCenter;
    @BindView(R.id.fl_live_voice_rise_fall)
    FrameLayout mVoiceRiseFallPop;
    @BindView(R.id.fl_live_voice_mix)
    FrameLayout mVoiceMixPop;
    @BindView(R.id.fl_live_voice_change)
    FrameLayout mVoiceChangePop;
    @BindView(R.id.fl_live_qrcode)
    FrameLayout mQrcodePop;
    @BindView(R.id.live_voice_change_pattern)
    RadioGroup mVoiceChangeRG;
    @BindView(R.id.live_beauty_pattern)
    RadioGroup mBeautyLevelRG;
    @BindView(R.id.live_filter_pattern)
    RadioGroup mFilterRG;
    @BindView(R.id.live_voice_rise_fall)
    RadioGroup mVoiceRiseFallRG;
    @BindView(R.id.tb_mirror_push)
    ToggleButton mMirrorPushTB;
    @BindView(R.id.tb_voice_denoise)
    ToggleButton mVoiceDenoiseTB;
    @BindView(R.id.tb_auto_focus)
    ToggleButton mAutoFocusTB;
    @BindView(R.id.tb_float_push)
    ToggleButton mFloatPushTB;
    @BindView(R.id.tb_ears_back)
    ToggleButton mEarsBackTB;
    @BindView(R.id.tb_lock_push)
    ToggleButton mPushLockTB;
    @BindView(R.id.camera_hint)
    CameraView mCameraHintView;
    @BindView(R.id.water_mark_local_upload)
    Button mUploadWaterMarkImage;
    @BindView(R.id.sb_water_mark_alpha)
    SeekBar mWaterMarkAlpha;
    @BindView(R.id.ll_water_mark_color)
    LinearLayout mLLWaterMarkColor;
    @BindView(R.id.sb_mix_voice_bg_volume)
    SeekBar mBgVolumeSb;
    @BindView(R.id.sb_mix_voice_mix_volume)
    SeekBar mMixVolumeSb;
    @BindView(R.id.ll_push_audio_only)
    LinearLayout mLLAudioOnlyPush;
    @BindView(R.id.water_mark_time)
    Button mWaterTimeBtn;
    @BindView(R.id.water_mark_text)
    Button mWaterTextBtn;
    @BindView(R.id.water_mark_photo)
    Button mWaterPhotoBtn;
    @BindView(R.id.water_mark_color_greed)
    Button mColorGreed;
    @BindView(R.id.water_mark_color_green)
    Button mColorGreen;
    @BindView(R.id.water_mark_color_blue)
    Button mColorBlue;
    @BindView(R.id.water_mark_color_red)
    Button mColorRed;
    @BindView(R.id.water_mark_color_yellow)
    Button mColorYellow;
    @BindView(R.id.water_mark_color_orange)
    Button mColorOrange;
    @BindView(R.id.paint_view)
    PaintView mPaintView;
    @BindView(R.id.tv_live_qrcode)
    TextView mQrcodeText;
    @BindView(R.id.iv_live_qrcode)
    ImageView mQrcodeImage;
    @BindView(R.id.iv_ab_record_point)
    ImageView mRecordPoint;
    @BindView(R.id.cm_ab_record)
    Chronometer mRecordCM;
    @BindView(R.id.iv_live_push_paint)
    ImageView mPainIV;
    @BindView(R.id.iv_live_push_beauty)
    ImageView mBeautyIV;


    private CameraTouch mCameraTouch;
    private boolean mRotateLock;
    private float mWaterMarkAlphaVal = 0.9f;
    private SeniorConfig mSeniorConfig;
    private BaseConfig mBaseConfig;
    public JDCloudLive mStreamer;
    private boolean mIsFlashOpened;
    private boolean isAudioOnlyPush;
    private boolean mStreaming;
    private boolean isMute;
    private boolean isPaint;
    private boolean isRecording;
    private Handler mUIHandler;
    private String mRecordPath = Environment.getExternalStorageDirectory().getPath() + "/jdc_live_record.mp4";
    private String mBgImagePath = "assets://push.png";
    private boolean mEnterPushEnd;//用来标识是否进入推流结束页面，true 不进入，false 进入
    private static final int MSG_SHOW_TOAST = 0x1001;
    private static final int MSG_SHOW_IMAGE_TOAST = 0x1002;
    private static final int MSG_RE_PUSH = 0x1003;
    private boolean mIsLandScape;
    private boolean mQRShow;
    private boolean mSwitchCamera = false;
    //pip
    private boolean mIsPIPMode;
    private String mPIPVideoPath = "rtmp://114.80.161.132/live?vhost=live.kksmg.com/dtv5cac91bb_884e43c1b0448869a69d6090";

    @Override
    public void initView() {
        setContentView(R.layout.activity_live_push);
        ButterKnife.bind(this);
        ActivityUtil.INSTANCE.addActivity(this);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
    }

    @OnClick(R.id.iv_live_push_cmd)
    public void startPush() {
        if (mStreaming) {
            stopStream();
        } else {
            if (!CommonUtils.isNetworkOk(this)) {
                Toast.makeText(this, "请检查网络连接！", Toast.LENGTH_SHORT).show();
            } else {
                startStream();
            }
        }
    }

    private int mLastRotation;

    private void handleOnResume() {
        mStreamer.onResume();
        if (mIsPIPMode) {
//            ((JDCloudPIPLive) mStreamer).getMediaPlayerCapture().getMediaPlayer().start();
            if (mOrientationEventListener != null) {
                mOrientationEventListener.disable();
            }
        }
        if (!isAudioOnlyPush) {
            mStreamer.stopImageCapture();
            mStreamer.startCameraPreview(mIsLandScape);
            mBeautyIV.setVisibility(View.VISIBLE);
        } else {
            mStreamer.stopCameraPreview();
            mStreamer.startImageCapture(mBgImagePath);
            mBeautyIV.setVisibility(View.GONE);
        }

        if (mOrientationEventListener != null && !mRotateLock && !mIsPIPMode) {
            if (mOrientationEventListener.canDetectOrientation()) {
                mOrientationEventListener.enable();
            }
            int rotation = getDisplayRotation();
            mStreamer.setRotateDegrees(rotation);
            mLastRotation = rotation;
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        if (mFloatPushTB.getToggleStatus()) {
            LogUtil.d(TAG, "go float view logic ");
        } else {
            handleOnPause();
        }
    }

    protected void handleOnPause() {
        if (mStreaming) {
            mStreamer.onPause();
            if (isAudioOnlyPush || (mSeniorConfig != null && !mSeniorConfig.mBackgroundPush)) {
                mStreamer.stopCameraPreview();
                mStreamer.startImageCapture(mBgImagePath);
                mBeautyIV.setVisibility(View.GONE);
            }
            if (mIsPIPMode) {
//                ((JDCloudPIPLive) mStreamer).getMediaPlayerCapture().getMediaPlayer().pause();
//                ((JDCloudPIPLive) mStreamer).getPictureCapture().stop();
            }
        } else if (mStreamer != null && isAudioOnlyPush) {
            mStreamer.stopCameraPreview();
            mStreamer.startImageCapture(mBgImagePath);
            mBeautyIV.setVisibility(View.GONE);
        }
        if (mOrientationEventListener != null) {
            mOrientationEventListener.disable();
        }
    }

    private void startPip() {
//        ((JDCloudPIPLive) mStreamer).getMediaPlayerCapture().getMediaPlayer()
//                .setOnCompletionListener(new IMediaPlayer.OnCompletionListener() {
//                    @Override
//                    public void onCompletion(IMediaPlayer iMediaPlayer) {
//                        Log.d(TAG, "End of the currently playing video");
//                        if (mStreamer != null) {
//                            ((JDCloudPIPLive) mStreamer).showBgVideo(mPIPVideoPath);
//                        }
//                    }
//                });
//        ((JDCloudPIPLive) mStreamer).getMediaPlayerCapture().getMediaPlayer()
//                .setOnErrorListener(new IMediaPlayer.OnErrorListener() {
//                    @Override
//                    public boolean onError(IMediaPlayer iMediaPlayer, int what, int extra) {
//                        Log.e(TAG, "MediaPlayer error, what=" + what + " extra=" + extra);
//                        return false;
//                    }
//                });
//        ((JDCloudPIPLive) mStreamer).showBgVideo(mPIPVideoPath);
//        ((JDCloudPIPLive) mStreamer).getMediaPlayerCapture().getMediaPlayer().setVolume(0.4f, 0.4f);
//        ((JDCloudPIPLive) mStreamer).setRect(((JDCloudPIPLive) mStreamer).getPlayerIdx(), 0.12f, 0.10f, 1.3f, 0.2f);
//        ((JDCloudPIPLive) mStreamer).setRect(((JDCloudPIPLive) mStreamer).getCameraIdx(), 0.f, 0.f, 1.f, 1.f);
        if (mCameraTouch != null) {
            mCameraTouch.setEnableTouchFocus(false);
        }

    }

    private void stopPip() {
        if (mStreamer != null) {
//            ((JDCloudPIPLive) mStreamer).hideBgVideo();
        }
        mIsPIPMode = false;
        if (mCameraTouch != null) {
            mCameraTouch.setEnableTouchFocus(true);
        }
    }

    private void setCameraParam() {
        Camera.Parameters parameters = mStreamer.getCameraCapture().getCameraParameters();
        if (parameters != null) {
            parameters.setAntibanding(Camera.Parameters.ANTIBANDING_50HZ);
            mStreamer.getCameraCapture().setCameraParameters(parameters);
        }
    }


    @Override
    protected void onResume() {
        super.onResume();
        if (!isAudioOnlyPush) {
            clearUI();
        }
        if (mStreamer != null) {
            handleOnResume();
        }

    }

    @Override
    public void initData() {
        mUIHandler = new UIHandler();
        mBaseConfig = (BaseConfig) getIntent().getSerializableExtra(Constant.PUSH_BASE_CONFIG);
        mSeniorConfig = (SeniorConfig) getIntent().getSerializableExtra(Constant.PUSH_SENIOR_CONFIG);
        if (mBaseConfig == null && mSeniorConfig == null) {
            return;
        } else {
            if (mSeniorConfig != null && mSeniorConfig.mUrl == null) {
                mSeniorConfig.mUrl = SharePreferenceUtil.getInstance().getPushUrl();
            } else if (mBaseConfig != null && mBaseConfig.mUrl == null) {
                mBaseConfig.mUrl = SharePreferenceUtil.getInstance().getPushUrl();
            }
        }
        //init screen sensor
//        sm = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
//        sensor = sm.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
        initStreamer();
    }

    private void initStreamer() {
        if (mSeniorConfig != null && mSeniorConfig.mPIPMode) {
            mIsPIPMode = true;
//            mStreamer = new JDCloudPIPLive(this);
        } else {
            mStreamer = new JDCloudLive(this);
        }
        PushUtil.INSTANCE.setStreamer(mStreamer);

        if (mSeniorConfig != null) {
            mStreamer.setUrl(mSeniorConfig.mUrl);
            mStreamer.setEnableRepeatLastFrame(false);
            // 设置推流分辨率
            mStreamer.setPreviewResolution(mSeniorConfig.mPreviewResolution);
            mStreamer.setTargetResolution(mSeniorConfig.mPushResolution);
            mStreamer.setCameraCaptureResolution(mSeniorConfig.mCaptureResolution);

            // 设置编码方式（硬编、软编）
            mStreamer.setEncodeMethod(mSeniorConfig.mVideoEncodedFunc);
            // 硬编模式下默认使用高性能模式(high profile)
            if (mSeniorConfig.mVideoEncodedFunc == BaseConstants.ENCODE_METHOD_HARDWARE) {
                mStreamer.setVideoEncodeProfile(VideoEncodeFormat.ENCODE_PROFILE_HIGH_PERFORMANCE);
            }

            // 设置推流帧率
            if (mSeniorConfig.mFrameRate > 0) {
                mStreamer.setPreviewFps(mSeniorConfig.mFrameRate);
                mStreamer.setTargetFps(mSeniorConfig.mFrameRate);
            } else {
                mStreamer.setPreviewFps(Constant.DEFAULT_FRAME_RATE);
                mStreamer.setTargetFps(Constant.DEFAULT_FRAME_RATE);
            }

            // 设置推流视频码率，三个参数分别为初始码率、最高码率、最低码率
            int videoBitrate = mSeniorConfig.mBitRate;
            mStreamer.setVideoKBitrate(videoBitrate * 3 / 4, videoBitrate, videoBitrate / 4);

            // 设置音频码率
            mStreamer.setAudioKBitrate(mSeniorConfig.mAudioBitrate);

            // 设置音频通道
            mStreamer.setAudioChannels(mSeniorConfig.mVoiceChannel);

            // 设置视频方向（横屏、竖屏）
            if (mSeniorConfig.mOrientation == ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE) {
                mStreamer.setRotateDegrees(90);
                mIsLandScape = true;
            } else if (mSeniorConfig.mOrientation == ActivityInfo.SCREEN_ORIENTATION_FULL_SENSOR) {
                mOrientationEventListener = new PushOrientationEventListener(this, SensorManager.SENSOR_DELAY_NORMAL);
            } else {
                mStreamer.setRotateDegrees(0);
                mIsLandScape = false;
            }
            setRequestedOrientation(mSeniorConfig.mOrientation);
            // 选择前后摄像头
            mStreamer.setCameraFacing(mSeniorConfig.mCameraPattern);

            // 设置预览View
            mStreamer.setDisplayPreview(mGLSurface);
            // 设置重连
        } else if (mBaseConfig != null) {
            mStreamer.setUrl(mBaseConfig.mUrl);
            // 设置推流分辨率
            mStreamer.setPreviewResolution(mBaseConfig.mResolution);
            mStreamer.setTargetResolution(mBaseConfig.mResolution);

            // 设置编码方式（硬编、软编）
            mStreamer.setEncodeMethod(BaseConstants.ENCODE_METHOD_HARDWARE);
            mStreamer.setVideoEncodeProfile(VideoEncodeFormat.ENCODE_PROFILE_HIGH_PERFORMANCE);

            // 设置推流视频码率，三个参数分别为初始码率、最高码率、最低码率
            int videoBitrate = 800;
            mStreamer.setVideoKBitrate(videoBitrate * 3 / 4, videoBitrate, videoBitrate / 4);
            mStreamer.setRotateDegrees(0);
            mStreamer.setCameraFacing(CameraCapture.FACING_FRONT);
            mStreamer.setDisplayPreview(mGLSurface);
        }
        if (mIsPIPMode) {
            startPip();
        }
    }

    private InfoListener mOnInfoListener = new InfoListener() {
        @Override
        public void onInfo(int what, int msg1, int msg2) {
            onStreamerInfo(what, msg1, msg2);
        }
    };

    private ErrorListener mOnErrorListener = new ErrorListener() {
        @Override
        public void onError(int what, int msg1, int msg2) {
            onStreamerError(what, msg1, msg2);
        }
    };

    protected void onStreamerInfo(int what, int msg1, int msg2) {
        LogUtil.d(TAG, "OnInfo: " + what + " msg1: " + msg1 + " msg2: " + msg2);
        switch (what) {
            case BaseConstants.LIVE_CAMERA_INIT_DONE:
                if (mStreamer != null) {
                    setCameraParam();
                }
                LogUtil.d(TAG, "LIVE_CAMERA_INIT_DONE");
                break;
            case BaseConstants.LIVE_CAMERA_FACING_CHANGED:
                LogUtil.d(TAG, "LIVE_CAMERA_FACING_CHANGED");
                break;
            case BaseConstants.LIVE_OPEN_SUCCESS:
                LogUtil.d(TAG, "LIVE_OPEN_SUCCESS");
                mEnterPushEnd = false;
                mRetryCount = 0;
                mPushText.setText(R.string.media_push_end);
                startChronometer();
                break;
            case BaseConstants.LIVE_FRAME_SEND_SLOW:
                LogUtil.d(TAG, "LIVE_FRAME_SEND_SLOW " + msg1 + "ms");
                Toast.makeText(PushActivity.this, "Network not good!",
                        Toast.LENGTH_SHORT).show();
                break;
            case BaseConstants.LIVE_EST_BW_RAISE:
                LogUtil.d(TAG, "LIVE_EST_BW_RAISE " + msg1 / 1000 + "kbps");
                break;
            case BaseConstants.LIVE_EST_BW_DROP:
                LogUtil.d(TAG, "LIVE_EST_BW_DROP " + msg1 / 1000 + "kpbs");
                break;
            default:
                break;
        }
    }

    protected void onStreamerError(int what, int msg1, int msg2) {
        LogUtil.e(TAG, "streaming error: what=" + what + " msg1=" + msg1 + " msg2=" + msg2);
        String errorMsg;
        switch (what) {
            case BaseConstants.STREAMER_ERROR_DNS_PARSE_FAILED:
                errorMsg = "STREAMER_ERROR_DNS_PARSE_FAILED";
                break;
            case BaseConstants.STREAMER_ERROR_CONNECT_FAILED:
                errorMsg = "连接失败，请检查网络是否断开";
                break;
            case BaseConstants.STREAMER_ERROR_PUBLISH_FAILED:
                errorMsg = "STREAMER_ERROR_PUBLISH_FAILED";
                break;
            case BaseConstants.STREAMER_ERROR_CONNECT_BREAKED:
                errorMsg = "推连接失败，请修改推流地址重试";
                break;
            case BaseConstants.STREAMER_ERROR_AV_ASYNC:
                errorMsg = "STREAMER_ERROR_AV_ASYNC " + msg1 + "ms";
                break;
            case BaseConstants.VIDEO_ENCODER_ERROR_UNSUPPORTED:
                errorMsg = "STREAMER_VIDEO_ENCODER_ERROR_UNSUPPORTED";
                break;
            case BaseConstants.VIDEO_ENCODER_ERROR_UNKNOWN:
                errorMsg = "STREAMER_VIDEO_ENCODER_ERROR_UNKNOWN";
                break;
            case BaseConstants.AUDIO_ENCODER_ERROR_UNSUPPORTED:
                errorMsg = "STREAMER_AUDIO_ENCODER_ERROR_UNSUPPORTED";
                break;
            case BaseConstants.AUDIO_ENCODER_ERROR_UNKNOWN:
                errorMsg = "STREAMER_AUDIO_ENCODER_ERROR_UNKNOWN";
                break;
            case BaseConstants.AUDIO_RECORDER_ERROR_START_FAILED:
                errorMsg = "请打开麦克风权限，重新推流";
                break;
            case BaseConstants.AUDIO_RECORDER_ERROR_UNKNOWN:
                errorMsg = "STREAMER_AUDIO_RECORDER_ERROR_UNKNOWN";
                break;
            case BaseConstants.STREAMER_ERROR_ALREADY_EXIST_STREAM_NAME:
                errorMsg = "流名相同 请更换";
                break;
            case BaseConstants.STREAMER_ERROR_SIGNATURE_NOT_MATCH:
                errorMsg = "签名不匹配";
                break;
            case  BaseConstants.STREAMER_ERROR_REFER_NOT_MATCH:
                errorMsg = "refer鉴权失败";
                break;
            case BaseConstants.STREAMER_ERROR_FORBIDDEN:
                errorMsg = "流被拒绝";
                break;
            case BaseConstants.STREAMER_ERROR_INVALID_ACCESS_KEY:
                errorMsg = "无效的AccessKey";
                break;
            case  BaseConstants.STREAMER_ERROR_MISS_ACCESS_KEY:
                errorMsg = "缺少access key";
                break;
            case BaseConstants.STREAMER_ERROR_INTERNAL_ERROR:
                errorMsg = "推流失败 未知原因";
                break;
            default:
                errorMsg = "what=" + what + " msg1=" + msg1 + " msg2=" + msg2;
                LogUtil.d(TAG, "what=" + what + " msg1=" + msg1 + " msg2=" + msg2);
                break;
        }
        mEnterPushEnd = true;
        stopStream();
        if (mUIHandler != null) {
            mUIHandler.obtainMessage(MSG_SHOW_TOAST, errorMsg).sendToTarget();
        }
        switch (what) {
            case BaseConstants.CAMERA_ERROR_UNKNOWN:
            case BaseConstants.CAMERA_ERROR_START_FAILED:
            case BaseConstants.CAMERA_ERROR_EVICTED:
            case BaseConstants.CAMERA_ERROR_SERVER_DIED:
                if (mStreamer != null) {
                    mStreamer.stopCameraPreview();
                }
                break;
            case BaseConstants.VIDEO_ENCODER_ERROR_UNSUPPORTED:
            case BaseConstants.VIDEO_ENCODER_ERROR_UNKNOWN:
                handleEncodeError();
                break;
            case BaseConstants.STREAMER_ERROR_DNS_PARSE_FAILED:
            case BaseConstants.STREAMER_ERROR_CONNECT_FAILED:
            case BaseConstants.STREAMER_ERROR_PUBLISH_FAILED:
            case BaseConstants.STREAMER_ERROR_CONNECT_BREAKED:
            case BaseConstants.STREAMER_ERROR_AV_ASYNC:
                rePush();
                break;
            default:
                break;
        }
    }


    private long pushStartTime;
    private String pushDuration;

    //start streaming
    protected void startStream() {
        mStreamer.startPush();
        mPushImage.setImageResource(R.drawable.ic_push_end);
        mPushText.setText(R.string.media_push_end);
        mRedPoint.setVisibility(View.VISIBLE);
        mStreaming = true;
        //fix bug LIVE-782
        if (isPaint) {
            stopPaint();
            startPaint();
        }
        //如果是纯音频推流模拟后台推送
        if (isAudioOnlyPush) {
            handleOnPause();
            mContainer.setBackground(new BitmapDrawable(BitmapUtil.loadBitmap(this, mBgImagePath)));
            mBeautyIV.setVisibility(View.GONE);
            mLLAudioOnlyPushView.setVisibility(View.VISIBLE);
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mUIHandler != null) {
            mUIHandler.removeCallbacksAndMessages(null);
            mUIHandler = null;
        }
        if (mIsPIPMode) {
            stopPip();
        }
        if (!mFloatPushTB.getToggleStatus()) {
            PushUtil.INSTANCE.destroyStreamer();
        }
    }

    protected void stopStream() {
        if (mStreamer == null) {
            PushUtil.INSTANCE.destroyStreamer();
            return;
        }
        if (isPaint) {
            stopPaint();
            isPaint = false;
        }
        //fix bug LIVE-780
        if (mSwitchCamera) {
            mStreamer.switchCamera();
            mSwitchCamera = false;
        }
        // fix bug LIVE-779
        if (isAudioOnlyPush) {
            mStreamer.stopImageCapture();
            isAudioOnlyPush = false;
        }

        mStreamer.stopPush();
        mPushImage.setImageResource(R.drawable.ic_push_start);
        mPushText.setText(R.string.media_push_start);
        mRedPoint.setVisibility(View.GONE);
        mStreaming = false;

        if (mIsPIPMode) {
            stopPip();
        }
        stopChronometer();
        if (isRecording) {
            stopRecord();
        }
        mStreamer.stopBgm();
        if (!mEnterPushEnd) {
            goPushEnd();
        }
    }

    private void goPushEnd() {
        Intent i = new Intent(this, PushEndActivity.class);
        i.putExtra(Constant.LIVE_EXTRA_PUSH_DURATION, pushDuration);
        startActivity(i);
    }

    private void startChronometer() {
        pushStartTime = System.currentTimeMillis();
        mCHMLive.setBase(SystemClock.elapsedRealtime());
        mCHMLive.start();
    }

    protected void stopChronometer() {
        pushDuration = CommonUtils.formattedTime(System.currentTimeMillis() - pushStartTime);
        mCHMLive.setBase(SystemClock.elapsedRealtime());
        mCHMLive.stop();
    }

    protected void handleEncodeError() {
        int encodeMethod = mStreamer.getVideoEncodeMethod();
        if (encodeMethod == BaseConstants.ENCODE_METHOD_HARDWARE) {
            mStreamer.setEncodeMethod(BaseConstants.ENCODE_METHOD_SOFTWARE);
            LogUtil.e(TAG, "Got HW encoder error, switch to SOFTWARE mode");
        } else if (encodeMethod == BaseConstants.ENCODE_METHOD_SOFTWARE) {
            LogUtil.e(TAG, "Got SW encoder error, we have nothing to do...");
        }
    }

    @Override
    public void initListener() {
        mStreamer.setOnInfoListener(mOnInfoListener);
        mStreamer.setOnErrorListener(mOnErrorListener);

        //init toggle listener
        mMirrorPushTB.setOnToggleChanged(this);
        mVoiceDenoiseTB.setOnToggleChanged(this);
        mAutoFocusTB.setOnToggleChanged(this);
        mFloatPushTB.setOnToggleChanged(this);
        mEarsBackTB.setOnToggleChanged(this);
        mPushLockTB.setOnToggleChanged(this);
    }

    @OnClick(R.id.iv_action_bar_back)
    public void backStack() {
        if (mStreaming) {
            if (mFloatPushTB.getToggleStatus()) {
                Intent i;
                if (mSeniorConfig != null) {
                    i = new Intent(this, PushSeniorSettingActivity.class);
                    i.putExtra(Constant.IS_FLOAT_PUSH, true);
                } else {
                    i = new Intent(this, PushSettingActivity.class);
                    i.putExtra(Constant.IS_FLOAT_PUSH, true);
                }
                startActivity(i);
            } else {
                if (mBackDialog != null && !mBackDialog.isShowing()) {
                    mBackDialog.show();
                } else {
                    mBackDialog = new CustomDialog.Builder(this).setTitle(R.string.dialog_exit_title).setContent(R.string.dialog_exit_content)
                            .setOkBtn(R.string.dialog_exit_ok).setCancelBtn(R.string.dialog_exit_cancel).setOkListener(
                                    new View.OnClickListener() {
                                        @Override
                                        public void onClick(View v) {
                                            mEnterPushEnd = true;
                                            stopStream();
                                            mStreamer = null;
                                            mBackDialog.dismiss();
                                            finish();
                                        }
                                    }
                            ).setCancelListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View v) {
                                    mBackDialog.dismiss();
                                }
                            }).createDialog();
                    mBackDialog.show();
                }
            }
        } else {
            if (mStreamer != null) {
                mStreamer.stopPush();
                mStreamer.stopBgm();
                if (mIsPIPMode) {
                    stopPip();
                }
                mStreamer = null;
            }
            finish();
        }
    }

    @OnClick(R.id.action_bar_record)
    public void handleRecord() {
        if (!mStreaming) {
            Toast.makeText(this, R.string.toast_live_record_tip, Toast.LENGTH_SHORT).show();
        } else {
            if (isRecording) {
                stopRecord();
            } else {
                mRecordPoint.setVisibility(View.VISIBLE);
                mStreamer.startRecord(mRecordPath);
                mRecordCM.setBase(SystemClock.elapsedRealtime());
                mRecordCM.setVisibility(View.VISIBLE);
                mRecordCM.start();
                isRecording = true;
            }
        }
    }

    private void stopRecord() {
        mStreamer.stopRecord();
        mRecordPoint.setVisibility(View.GONE);
        mRecordCM.setBase(SystemClock.elapsedRealtime());
        mRecordCM.setVisibility(View.GONE);
        mRecordCM.stop();
        isRecording = false;

        File file = new File(mRecordPath);
        Intent mediaScanIntent = new Intent(
                "android.intent.action.MEDIA_SCANNER_SCAN_FILE");
        Uri contentUri = Uri.fromFile(file);
        mediaScanIntent.setData(contentUri);
        getApplicationContext().sendBroadcast(mediaScanIntent);

    }

    @Override
    public void onBackPressed() {
        backStack();
    }

    //snapshot
    @OnClick(R.id.action_bar_cut)
    public void snapshot() {
        if (!mStreaming) {
            Toast.makeText(this, R.string.toast_live_record_tip, Toast.LENGTH_SHORT).show();
        } else {
            mStreamer.requestScreenShot(new GLRender.ScreenShotListener() {
                @Override
                public void onBitmapAvailable(Bitmap bitmap) {
                    Date date = new Date();
                    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss",
                            Locale.getDefault());
                    String path = Environment.getExternalStorageDirectory().getPath() +
                            "/jdc_live_" + dateFormat.format(date) + ".jpg";
                    CommonUtils.saveBitmap(bitmap, path);
                    mUIHandler.obtainMessage(MSG_SHOW_IMAGE_TOAST, path).sendToTarget();
                }
            });
        }
    }

    @OnClick(R.id.iv_live_push_beauty)
    public void showBeautyPop() {
        mLiveBeauty.setVisibility(View.VISIBLE);
        mBasePushView.setVisibility(View.GONE);
        handleBeauty();
    }

    @OnClick(R.id.rl_live_beauty_back)
    public void hideBeautyPop() {
        mLiveBeauty.setVisibility(View.GONE);
        mBasePushView.setVisibility(View.VISIBLE);
    }

    @OnClick(R.id.action_bar_more)
    public void showMorePop() {
        mLiveMore.setVisibility(View.VISIBLE);
        mBasePushView.setVisibility(View.GONE);
    }

    @OnClick(R.id.rl_live_more_back)
    public void hideMorePop() {
        mLiveMore.setVisibility(View.GONE);
        mBasePushView.setVisibility(View.VISIBLE);
    }

    @OnClick(R.id.iv_live_push_voice)
    public void setLiveMute() {
        if (isMute) {
            mMuteView.setImageResource(R.drawable.ic_voice);
            mStreamer.setMuteAudio(false);
            isMute = false;
        } else {
            mMuteView.setImageResource(R.drawable.ic_mute);
            mStreamer.setMuteAudio(true);
            isMute = true;
        }
    }

    @OnClick(R.id.action_bar_shot)
    public void switchCamera() {
        mSwitchCamera = !mSwitchCamera;
        mStreamer.switchCamera();
    }

    @OnClick(R.id.action_bar_flash)
    public void openCameraFlash() {
        if (mStreamer.isFrontCamera()) {
            Toast.makeText(this, "前置摄像头无法开启闪光灯", Toast.LENGTH_SHORT).show();
            return;
        }

        if (mIsFlashOpened) {
            // 关闭闪光灯
            mStreamer.toggleTorch(false);
            mIsFlashOpened = false;
        } else {
            // 开启闪光灯
            mStreamer.toggleTorch(true);
            mIsFlashOpened = true;
        }
    }

    private CustomDialog mDialog;
    private CustomDialog mBackDialog;

    @OnClick(R.id.tv_live_more_audio_only_push)
    public void audioOnlyPush() {
        if (mDialog != null) {
            if (!mDialog.isShowing()) {
                mDialog.show();
            }
        } else {
            mDialog = new CustomDialog.Builder(this).setOkListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
                    intent.setType("image/*");
                    startActivityForResult(intent, Constant.GET_BACKGROUND_REQUEST);
                    mDialog.dismiss();
                }
            }).setCancelListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    mDialog.dismiss();
                    mLLAudioOnlyPushView.setVisibility(View.VISIBLE);
                    mBgImagePath = "assets://push.png";
                    isAudioOnlyPush = true;
                    handleOnPause();
                }
            }).createDialog();
            mDialog.show();
        }
        hideMorePop();
        showBasePush();
    }

    @OnClick(R.id.rl_audio_only_push_return)
    public void returnNormalPush() {
        mLLAudioOnlyPushView.setVisibility(View.GONE);
        mContainer.setBackgroundResource(R.color.transparent);
        isAudioOnlyPush = false;
        handleOnResume();
    }

    @OnClick(R.id.tv_live_more_voice_call)
    public void handleAudioCall() {
        Intent i = new Intent(this, AudioCallListActivity.class);
        i.putExtra(Constant.AUDIO_CALL_INDEX, mAudioCallIndex);
        startActivityForResult(i, Constant.AUDIO_CALL_REQUEST);
    }

    private int mAudioCallIndex;

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == Constant.AUDIO_CALL_REQUEST && resultCode == RESULT_OK) {
            Bundle bundle = data.getExtras();
            String audioPath = bundle.getString(Constant.AUDIO_CALL_PATH);
            mAudioCallIndex = bundle.getInt(Constant.AUDIO_CALL_INDEX);
            //播放背景音乐
            if (mStreamer != null) {
                mStreamer.getAudioPlayerCapture().setVolume(0.4f);
                mStreamer.setEnableAudioMix(true);
                if (audioPath.endsWith("无")) {
                    mStreamer.stopBgm();

                } else mStreamer.startBgm(audioPath, true);
            }
        } else if (requestCode == Constant.GET_IMAGE_REQUEST && resultCode == RESULT_OK) {
            Bitmap bitmap = null;
            try {
                bitmap = MediaStore.Images.Media.getBitmap(PushActivity.this.getContentResolver(), data.getData());
            } catch (Exception e) {
                e.printStackTrace();
            }
            if (bitmap != null) {
                mWaterMarkCenter.setImageBitmap(bitmap);
                mWaterMarkCenter.setPhoto(true);
            }
        } else if (requestCode == Constant.GET_BACKGROUND_REQUEST && resultCode == RESULT_OK) {
            isAudioOnlyPush = true;
            mLLAudioOnlyPushView.setVisibility(View.VISIBLE);
            mBgImagePath = CommonUtils.getRealPathFromUri(this, data.getData());
            handleOnPause();
        }
    }

    @OnClick(R.id.tv_live_more_water_mark)
    public void showWaterMarkPop() {
        mWaterMarkPop.setVisibility(View.VISIBLE);
        handleWaterMark();
        hideMorePop();
        hideBasePush();
    }

    @OnClick(R.id.rl_live_water_mark_back)
    public void hideWaterMarkPop() {
        mWaterMarkPop.setVisibility(View.GONE);
        mWaterMarkCenter.setVisibility(View.GONE);
        showMorePop();
    }

    private boolean isTextWaterMrk;
    private boolean isTimeWaterMark;
    private int mWaterMarkColorVal = Color.WHITE;
    private WaterTypeClickListener mWaterTypeListener;
    private ColorClickListener mColorListener;

    class WaterTypeClickListener implements View.OnClickListener {
        @Override
        public void onClick(View v) {
            updateWaterTypeUi(v);
            switch (v.getId()) {
                case R.id.water_mark_time:
                    showTimeWater();
                    break;
                case R.id.water_mark_text:
                    showTextWater();
                    break;
                case R.id.water_mark_photo:
                    mWaterMarkCenter.setPhoto(false);
                    defaultWater();
                    break;
            }
        }
    }

    private void showTimeWater() {
        LogUtil.d(TAG, "water time checked");
        mUploadWaterMarkImage.setVisibility(View.GONE);
        mLLWaterMarkColor.setVisibility(View.VISIBLE);
        isTimeWaterMark = true;
        isTextWaterMrk = false;
        resetWaterPhoto();
        mWaterMarkCenter.showTime();
    }

    private void showTextWater() {
        LogUtil.d(TAG, "text water checked");
        mUploadWaterMarkImage.setVisibility(View.GONE);
        mLLWaterMarkColor.setVisibility(View.VISIBLE);
        isTextWaterMrk = true;
        isTimeWaterMark = false;
        resetWaterPhoto();
        mWaterMarkCenter.showText();
    }

    class ColorClickListener implements View.OnClickListener {
        @Override
        public void onClick(View v) {
            switch (v.getId()) {
                case R.id.water_mark_color_greed:
                    mWaterMarkColorVal = getResources().getColor(R.color.greed);
                    mWaterMarkCenter.updateTextColor(R.color.greed);
                    break;
                case R.id.water_mark_color_green:
                    mWaterMarkColorVal = getResources().getColor(R.color.green);
                    mWaterMarkCenter.updateTextColor(R.color.green);
                    break;
                case R.id.water_mark_color_blue:
                    mWaterMarkColorVal = getResources().getColor(R.color.blue);
                    mWaterMarkCenter.updateTextColor(R.color.blue);
                    break;
                case R.id.water_mark_color_red:
                    mWaterMarkColorVal = getResources().getColor(R.color.red);
                    mWaterMarkCenter.updateTextColor(R.color.red);
                    break;
                case R.id.water_mark_color_yellow:
                    mWaterMarkColorVal = getResources().getColor(R.color.yellow);
                    mWaterMarkCenter.updateTextColor(R.color.yellow);
                    break;
                case R.id.water_mark_color_orange:
                    mWaterMarkColorVal = getResources().getColor(R.color.orange);
                    mWaterMarkCenter.updateTextColor(R.color.orange);
                    break;
            }
            LogUtil.d(TAG, "water color is " + mWaterMarkColorVal);
        }
    }

    private void defaultWater() {
        isTimeWaterMark = false;
        isTextWaterMrk = false;

        mUploadWaterMarkImage.setVisibility(View.VISIBLE);
        mWaterMarkCenter.setVisibility(View.VISIBLE);
        mLLWaterMarkColor.setVisibility(View.GONE);
        mWaterMarkCenter.showPhoto();
    }

    private void updateWaterTypeUi(View v) {
        if (v == mWaterTimeBtn) {
            mWaterTimeBtn.setSelected(true);
            mWaterTextBtn.setSelected(false);
            mWaterPhotoBtn.setSelected(false);
        } else if (v == mWaterTextBtn) {
            mWaterTimeBtn.setSelected(false);
            mWaterTextBtn.setSelected(true);
            mWaterPhotoBtn.setSelected(false);
        } else {
            mWaterTimeBtn.setSelected(false);
            mWaterTextBtn.setSelected(false);
            mWaterPhotoBtn.setSelected(true);
        }
    }

    private void handleWaterMark() {
        if (mWaterTypeListener == null) {
            mWaterTypeListener = new WaterTypeClickListener();
        }
        mWaterTimeBtn.setOnClickListener(mWaterTypeListener);
        mWaterTextBtn.setOnClickListener(mWaterTypeListener);
        mWaterPhotoBtn.setOnClickListener(mWaterTypeListener);
        if (mColorListener == null) {
            mColorListener = new ColorClickListener();
        }
        mColorGreen.setOnClickListener(mColorListener);
        mColorGreed.setOnClickListener(mColorListener);
        mColorBlue.setOnClickListener(mColorListener);
        mColorRed.setOnClickListener(mColorListener);
        mColorYellow.setOnClickListener(mColorListener);
        mColorOrange.setOnClickListener(mColorListener);
        updateWaterTypeUi(mWaterTextBtn);
        showTextWater();
        mWaterMarkAlphaVal = (float) (mWaterMarkAlpha.getProgress() / 100.0);
        mWaterMarkAlpha.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                mWaterMarkAlphaVal = (float) (progress / 100.0);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        mWaterMarkCenter.setClickListener(new WaterMarkEditView.IClickListener() {
            @Override
            public void onDeleteClick() {
                //撤销水印
                if (isTimeWaterMark || isTextWaterMrk) {

                } else {
                    resetWaterPhoto();
                }
                mWaterMarkCenter.setVisibility(View.GONE);
            }

            @Override
            public void onEditClick() {
                //修改水印
            }

            @Override
            public void onSaveClick() {
                //确认水印
                float x = CommonUtils.covertValWidth(PushActivity.this, mWaterMarkCenter.getImageX());
                float y = CommonUtils.convertValHeight(PushActivity.this, mWaterMarkCenter.getImageY());
                float w = CommonUtils.covertValWidth(PushActivity.this, mWaterMarkCenter.getImageWidth());
                float h = CommonUtils.convertValHeight(PushActivity.this, mWaterMarkCenter.getImageHeight());
                if (isTextWaterMrk) {
                    mStreamer.showWaterMarkText(16, mWaterMarkCenter.getWaterText(), x, y, w, mWaterMarkColorVal, mWaterMarkAlphaVal);
                } else if (isTimeWaterMark) {
                    LogUtil.d(TAG, "show water color is " + mWaterMarkColorVal);
                    mStreamer.showWaterMarkTime(16, x, y, w, mWaterMarkColorVal, mWaterMarkAlphaVal);
                } else {
                    mStreamer.showWaterMarkPhoto(mWaterMarkCenter.getImageBitmap(), x, y, w, h, mWaterMarkAlphaVal);
                }
                mWaterMarkCenter.setVisibility(View.GONE);
            }
        });
    }

    private void resetWaterPhoto() {
        Bitmap bit = BitmapFactory.decodeResource(getResources(), R.drawable.water_mark_bg);
        mWaterMarkCenter.setImageBitmap(bit);
        mWaterMarkCenter.setPhoto(false);
    }

    @OnClick(R.id.water_mark_local_upload)
    public void chooseWaterMarkImage() {
        if (mWaterMarkCenter.getVisibility() == View.VISIBLE) {
            Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
            intent.setType("image/*");
            startActivityForResult(intent, Constant.GET_IMAGE_REQUEST);
        } else {
            Toast.makeText(this, "请先点击图片选项！", Toast.LENGTH_SHORT).show();
        }

    }

    @OnClick(R.id.tv_live_more_voice_rise_fall)
    public void showVoiceRiseFallPop() {
        mVoiceRiseFallPop.setVisibility(View.VISIBLE);
        handleVoiceRiseFall();
        hideMorePop();
        hideBasePush();
    }

    @OnClick(R.id.iv_voice_rise_fall_back)
    public void hideVoiceRiseFallPop() {
        mVoiceRiseFallPop.setVisibility(View.GONE);
        showMorePop();
    }

    @OnClick(R.id.tv_live_more_mix_voice)
    public void showVoiceMixPop() {
        mVoiceMixPop.setVisibility(View.VISIBLE);
        handleVoiceMix();
        hideMorePop();
        hideBasePush();
    }

    @OnClick(R.id.iv_mix_voice_back)
    public void hideVoiceMixPop() {
        mVoiceMixPop.setVisibility(View.GONE);
        showMorePop();
    }

    @OnClick(R.id.tv_live_more_voice_change)
    public void showVoiceChangePop() {
        mVoiceChangePop.setVisibility(View.VISIBLE);
        hideMorePop();
        hideBasePush();
        mVoiceChangeRG.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                handleVoiceChange();
            }
        });
    }

    @OnClick(R.id.iv_voice_change_back)
    public void hideVoiceChangePop() {
        mVoiceChangePop.setVisibility(View.GONE);
        showMorePop();
    }

    @OnClick(R.id.action_bar_qrcode)
    public void handleQrcode() {

        String playUrl = mBaseConfig != null ? mBaseConfig.mUrl.replace("pu", "pl") : mSeniorConfig.mUrl.replace("pu", "pl");

        mQrcodeText.setText(playUrl);

        mQrcodeImage.setImageBitmap(CommonUtils.createQRImage(playUrl, getResources().getDimensionPixelSize(R.dimen.water_mark_photo_width), getResources().getDimensionPixelSize(R.dimen.water_mark_photo_width)));

        mQrcodePop.setVisibility(View.VISIBLE);
        mQRShow = true;
        if (mIsLandScape) {
            hideBasePush();
        }
    }

    @OnClick(R.id.rl_live_qrcode_back)
    public void qrcodeBack() {
        mQrcodePop.setVisibility(View.GONE);
        mQRShow = false;
        showBasePush();
    }


    @OnClick(R.id.iv_live_push_paint)
    public void handlePaint() {
        if (isPaint) {
            stopPaint();
            isPaint = false;
        } else {
            startPaint();
            isPaint = true;
        }
    }

    private void stopPaint() {
        stopPaintViewCapture();
        mPaintView.clear();
        mPaintView.setVisibility(View.GONE);
        mPainIV.setImageResource(R.drawable.ic_paint);
    }

    private void startPaint() {
        mPaintView.setVisibility(View.VISIBLE);
        mPaintView.setColor(Color.YELLOW);
        mPaintView.setBgColor(Color.TRANSPARENT);
        mPaintView.setStrokeWidth(10);
        mPaintView.setGestureEnable(false);
        mPaintView.setVisibility(View.VISIBLE);
        mPainIV.setImageResource(R.drawable.ic_painted);
        initPaintViewCapture();
        startPaintViewCapture();
    }

    private static final int PAINT_VIEW_IDX = 7;
    private ViewCapture mPaintViewCapture;

    void initPaintViewCapture() {
        if (mPaintViewCapture != null) {
            return;
        }

        mPaintViewCapture = new ViewCapture(mStreamer.getGLRender());
        // connect to the empty last sink pin of graph mixer
        mPaintViewCapture.getSrcPin().connect(
                mStreamer.getImgTexMixer().getSinkPin(PAINT_VIEW_IDX));
        // set render position relative to the video
        mStreamer.showPaintView(PAINT_VIEW_IDX, 0, 0, 1, 1, 1);

        // restart PaintViewCapture while view layout changed
        mPaintView.addOnLayoutChangeListener(new View.OnLayoutChangeListener() {
            @Override
            public void onLayoutChange(View v, int left, int top, int right, int bottom,
                                       int oldLeft, int oldTop, int oldRight, int oldBottom) {
                int oldW = oldRight - oldLeft;
                int oldH = oldBottom - oldTop;
                if (isPaint && (oldW * oldH != 0)) {
                    stopPaintViewCapture();
                    startPaintViewCapture();
                }
            }
        });
    }

    private void startPaintViewCapture() {
        if (mPaintViewCapture != null) {
            mPaintViewCapture.setTargetResolution(mStreamer.getTargetWidth(),
                    mStreamer.getTargetHeight());
            mPaintViewCapture.setUpdateFps(mStreamer.getTargetFps());
            mPaintViewCapture.start(mPaintView);
        }
    }

    private void stopPaintViewCapture() {
        if (mPaintViewCapture != null) {
            mPaintViewCapture.stop();
        }
    }

    private void handleVoiceMix() {
        mBgVolumeSb.setOnSeekBarChangeListener(new SeekChangeListener(0));
        AudioManager audioManager = (AudioManager) DemoApplication.getContext().getSystemService(Context.AUDIO_SERVICE);
        int maxVolume = audioManager.getStreamMaxVolume(AudioManager.STREAM_SYSTEM);
        mBgVolumeSb.setMax(maxVolume);
        mBgVolumeSb.setProgress(maxVolume / 5);

        mMixVolumeSb.setOnSeekBarChangeListener(new SeekChangeListener(1));
    }

    private void handleVoiceChange() {
        List<AudioFilterBase> filters = new LinkedList<>();
        AudioEffectFilter audioEffect;
        switch (mVoiceChangeRG.getCheckedRadioButtonId()) {
            case R.id.live_voice_change_1:
                audioEffect = new AudioEffectFilter(
                        AudioEffectFilter.AUDIO_EFFECT_TYPE_MALE);
                filters.add(audioEffect);
                break;
            case R.id.live_voice_change_2:
                audioEffect = new AudioEffectFilter(
                        AudioEffectFilter.AUDIO_EFFECT_TYPE_FEMALE);
                filters.add(audioEffect);
                break;
            case R.id.live_voice_change_3:
                audioEffect = new AudioEffectFilter(
                        AudioEffectFilter.AUDIO_EFFECT_TYPE_ROBOT);
                filters.add(audioEffect);
                break;
            case R.id.live_voice_change_4:
                audioEffect = new AudioEffectFilter(
                        AudioEffectFilter.AUDIO_EFFECT_TYPE_HEROIC);
                filters.add(audioEffect);
                break;
            case R.id.live_voice_change_0:
            default:
                filters = null;
                break;
        }
        mStreamer.getAudioFilterManager().setFilter(filters);
    }

    private float beautyVal;
    private int filterIndex = 16;

    private void handleBeauty() {
        mBeautyLevelRG.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (mBeautyLevelRG.getCheckedRadioButtonId()) {
                    case R.id.live_beauty_1:
                        beautyVal = 20 / 100.f;
                        break;
                    case R.id.live_beauty_2:
                        beautyVal = 40 / 100.f;
                        break;
                    case R.id.live_beauty_3:
                        beautyVal = 60 / 100.f;
                        break;
                    case R.id.live_beauty_4:
                        beautyVal = 80 / 100.f;
                        break;
                    case R.id.live_beauty_5:
                        beautyVal = 100 / 100.f;
                        break;
                    case R.id.live_beauty_0:
                    default:
                        beautyVal = 0.0f;
                        break;
                }
                ImgFilterBase beautyFilter = new ImgBeautyProFilter(mStreamer.getGLRender(), PushActivity.this, 3);
                beautyFilter.setGrindRatio(beautyVal);
                beautyFilter.setWhitenRatio(beautyVal);
                beautyFilter.setRuddyRatio(2 * beautyVal - 1);
                if (beautyVal == 0.0f) {
                    beautyFilter = null;
                }
                setFilter(beautyFilter);

            }
        });
        mFilterRG.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (mFilterRG.getCheckedRadioButtonId()) {
                    case R.id.live_filter_1:
                        filterIndex = 16;
                        break;
                    case R.id.live_filter_2:
                        filterIndex = 26;
                        break;
                    case R.id.live_filter_3:
                        filterIndex = 28;
                        break;
                    case R.id.live_filter_4:
                        filterIndex = 29;
                        break;
                    case R.id.live_filter_5:
                        filterIndex = 22;
                        break;
                    case R.id.live_filter_0:
                    default:
                        filterIndex = 27;
                        break;
                }
                ImgFilterBase filter = new ImgBeautySpecialEffectsFilter(mStreamer.getGLRender(),
                        PushActivity.this, filterIndex - 15);
                setFilter(filter);
            }
        });
    }

    private void setFilter(ImgFilterBase filter) {
        mStreamer.getImgTexFilterManager().setFilter(filter);
    }

    private int mVoiceRiseFallLevel;
    private OrientationEventListener mOrientationEventListener;


    private void handleVoiceRiseFall() {
        mVoiceRiseFallRG.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (checkedId) {
                    case R.id.live_voice_rise_fall_0:
                        mVoiceRiseFallLevel = -3;
                        break;
                    case R.id.live_voice_rise_fall_1:
                        mVoiceRiseFallLevel = -2;
                        break;
                    case R.id.live_voice_rise_fall_2:
                        mVoiceRiseFallLevel = -1;
                        break;
                    case R.id.live_voice_rise_fall_4:
                        mVoiceRiseFallLevel = 1;
                        break;
                    case R.id.live_voice_rise_fall_5:
                        mVoiceRiseFallLevel = 2;
                        break;
                    case R.id.live_voice_rise_fall_6:
                        mVoiceRiseFallLevel = 3;
                        break;
                    case R.id.live_voice_rise_fall_3:
                    default:
                        mVoiceRiseFallLevel = 0;
                        break;
                }
                AudioEffectFilter audioEffect = new AudioEffectFilter(
                        AudioEffectFilter.AUDIO_EFFECT_TYPE_PITCH);
                audioEffect.setPitchLevel(mVoiceRiseFallLevel);
                mStreamer.getAudioFilterManager().setFilter(audioEffect);
            }
        });
    }

    private void clearUI() {
        mLLAudioOnlyPushView.setVisibility(View.GONE);
        mBeautyIV.setVisibility(View.VISIBLE);
    }

    private void showBasePush() {
        mBasePushView.setVisibility(View.VISIBLE);
    }

    private void hideBasePush() {
        mBasePushView.setVisibility(View.GONE);
    }

    @Override
    public void onToggle(boolean on, int id) {
        switch (id) {
            case R.id.tb_mirror_push:
                mStreamer.setFrontCameraMirror(on);
                break;
            case R.id.tb_voice_denoise:
                mStreamer.setEnableAudioNS(on);
                break;
            case R.id.tb_auto_focus:
                if (on) {
                    mCameraTouch = new CameraTouch();
                    mCameraTouch.setCameraCapture(mStreamer.getCameraCapture());
                    mGLSurface.setOnTouchListener(mCameraTouch);
                    mCameraHintView.setVisibility(View.VISIBLE);
                    mCameraTouch.setCameraHintView(mCameraHintView);
                }
                break;
            case R.id.tb_ears_back:
                mStreamer.setEnableAudioPreview(on);
                break;
            case R.id.tb_lock_push:
                mRotateLock = on;
                if (on) {
                    if (mOrientationEventListener != null) {
                        mOrientationEventListener.disable();
                    }
                    int rotation = getDisplayRotation();
                    boolean isLandscape = rotation % 180 != 0;
                    if (isLandscape) {
                        // fix bug LIVE-776
                        if (rotation == 270) {
                            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_REVERSE_LANDSCAPE);
                        } else setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
                    } else {
                        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
                    }
                } else {
                    if (mOrientationEventListener != null) {
                        mOrientationEventListener.enable();
                    }
                    if (mSeniorConfig != null) {
                        setRequestedOrientation(mSeniorConfig.mOrientation);
                    }
                }
                break;
            case R.id.tb_float_push:
            default:
                break;
        }
    }

    private int mRetryCount;

    private void rePush() {
        if (mUIHandler == null) {
            return;
        }
        if (mSeniorConfig != null && mSeniorConfig.mReconnectCount > 0 && mSeniorConfig.mReconnectTime > 0) {
            if (mRetryCount < mSeniorConfig.mReconnectCount) {
                mUIHandler.sendEmptyMessageDelayed(MSG_RE_PUSH, mSeniorConfig.mReconnectTime);
                mRetryCount++;
            }

        } else if (mRetryCount < Constant.RETRY_TIMES) {
            mUIHandler.sendEmptyMessageDelayed(MSG_RE_PUSH, Constant.RETRY_LONG);
            mRetryCount++;
        }
    }

    class UIHandler extends Handler {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case MSG_SHOW_TOAST:
                    String content = (String) msg.obj;
                    Toast.makeText(PushActivity.this, content, Toast.LENGTH_SHORT).show();
                    break;
                case MSG_SHOW_IMAGE_TOAST:
                    String path = (String) msg.obj;
                    ToastUtil.getToast().makeToast(PushActivity.this, null, 2000);
                    ToastUtil.getToast().setImagePath(path);
                    ToastUtil.getToast().showToast();
                    break;
                case MSG_RE_PUSH:
                    startStream();
                    break;
                default:
                    break;
            }
        }
    }

    class PushOrientationEventListener extends OrientationEventListener {
        PushOrientationEventListener(Context context, int rate) {
            super(context, rate);
        }

        @Override
        public void onOrientationChanged(int orientation) {
            int rotation = getDisplayRotation();
            mIsLandScape = rotation % 180 != 0;
            if (mIsLandScape) {
                if (mQRShow) {
                    hideBasePush();
                }
            } else {
                showBasePush();
            }

            if (rotation != mLastRotation && !mRotateLock) {
                LogUtil.d(TAG, "Rotation changed " + mLastRotation + "->" + rotation);
                mStreamer.setRotateDegrees(rotation);
                mLastRotation = rotation;
            }
        }
    }

    class SeekChangeListener implements SeekBar.OnSeekBarChangeListener {
        private int mIndex;

        public SeekChangeListener(int index) {
            this.mIndex = index;
        }

        @Override
        public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
            if (mIndex == 1) {
                //fix bug LIVE-774
                mStreamer.getAudioCapture().setVolume((progress / 5) * 1.0f);
            } else {
                AudioManager audioManager = (AudioManager) DemoApplication.getContext().getSystemService(Context.AUDIO_SERVICE);
                audioManager.setStreamVolume(AudioManager.STREAM_MUSIC, progress, AudioManager.FLAG_PLAY_SOUND);
                mStreamer.getAudioPlayerCapture().setVolume(progress * 1.0f);
            }
        }

        @Override
        public void onStartTrackingTouch(SeekBar seekBar) {

        }

        @Override
        public void onStopTrackingTouch(SeekBar seekBar) {

        }
    }

    private int getDisplayRotation() {
        int rotation = getWindowManager().getDefaultDisplay().getRotation();
        switch (rotation) {
            case Surface.ROTATION_0:
                return 0;
            case Surface.ROTATION_90:
                return 90;
            case Surface.ROTATION_180:
                return 180;
            case Surface.ROTATION_270:
                return 270;
        }
        return 0;
    }
}
