package com.jdcloud.media.demo.utils;

import com.jdcloud.media.demo.base.BaseActivity;

import java.util.ArrayList;
import java.util.List;

public enum ActivityUtil {
    INSTANCE;
    private List<BaseActivity> mStack = new ArrayList<>();

    public void addActivity(BaseActivity activity) {
        if (mStack != null) {
            mStack.add(activity);
        }
    }

    public void finishActivity(BaseActivity activity) {
        if (activity != null) {
            activity.finish();
            mStack.remove(activity);
        }
    }

    public void finishActivity(Class<?> cls) {
        if (mStack != null) {
            for (BaseActivity activity : mStack) {
                if (activity.getClass().equals(cls)) {
                    mStack.remove(activity);
                    finishActivity(activity);
                    break;
                }
            }
        }
    }

    public BaseActivity currentActivity() {
        BaseActivity activity;
        if (mStack == null || mStack.isEmpty()) {
            return null;
        }
        activity = mStack.get(mStack.size() - 1);
        return activity;
    }

    public void finishAll() {
        while (true) {
            BaseActivity activity = currentActivity();
            if (activity == null) {
                break;
            }
            finishActivity(activity);
        }
    }

    public void exit() {
        finishAll();
        if (mStack != null) {
            mStack.clear();
            mStack = null;
        }
        android.os.Process.killProcess(android.os.Process.myPid());
    }
}
