package com.jdcloud.media.demo.utils;

import android.text.TextUtils;
import android.util.Log;

import com.jdcloud.media.demo.BuildConfig;

public class LogUtil {

    private final static String TAG = LogUtil.class.getSimpleName();

    private static boolean debug = BuildConfig.DEBUG;

    public static void d(String tag, String content) {
        if (!debug) {
            return;
        }
        if (TextUtils.isEmpty(tag)) {
            Log.d(TAG, content);
        } else {
            Log.d(tag, content);
        }
    }

    public static void e(String tag, String content) {
        if (!debug) {
            return;
        }
        if (TextUtils.isEmpty(tag)) {
            Log.e(TAG, content);
        } else {
            Log.e(tag, content);
        }
    }

    public static void i(String tag, String content) {
        if (!debug) {
            return;
        }
        if (TextUtils.isEmpty(tag)) {
            Log.i(TAG, content);
        } else {
            Log.i(tag, content);
        }
    }

    public static void d(String log) {
        d(TAG, log);
    }

    public static void i(String log) {
        i(TAG, log);
    }

    public static void e(String log) {
        e(TAG, log);
    }
}
