#! /bin/sh

JDCLOUD_THIRD_PARTY_LIBRARY_URL=git.jd.com:jdcloud_mt_sdk/jdcloud_third_party_library
JDCLOUD_THIRD_PARTY_LIBRARY_DIR=../jdcloud_third_party_library
JDCLOUD_THIRD_PARTY_LIBRARY_BRANCH=master

JDCLOUD_STREAMER_ANDROID_URL=git.jd.com:jdcloud_mt_sdk/jdcloud_streamer_android
JDCLOUD_STREAMER_ANDROID_DIR=../jdcloud_streamer_android
JDCLOUD_STREAMER_ANDROID_BRANCH=master

echo "====================== check third_party_library ======================"
if [ ! -d "$JDCLOUD_THIRD_PARTY_LIBRARY_DIR" ] ; then
echo "can't find $JDCLOUD_THIRD_PARTY_LIBRARY_DIR, clone again"
git lfs clone git@${JDCLOUD_THIRD_PARTY_LIBRARY_URL}.git $JDCLOUD_THIRD_PARTY_LIBRARY_DIR
fi
cd $JDCLOUD_THIRD_PARTY_LIBRARY_DIR
git fetch origin
git reset --hard
git checkout $JDCLOUD_STREAMER_ANDROID_BRANCH
git pull origin $JDCLOUD_STREAMER_ANDROID_BRANCH
cd -

echo "====================== check jdcloud_streamer_android ====================="
if [ ! -d "$JDCLOUD_STREAMER_ANDROID_DIR" ] ; then
echo "can't find $JDCLOUD_STREAMER_ANDROID_DIR, clone again"
git lfs clone git@${JDCLOUD_STREAMER_ANDROID_URL}.git $JDCLOUD_STREAMER_ANDROID_DIR
fi
cd $JDCLOUD_STREAMER_ANDROID_DIR
git fetch origin
git reset --hard
git checkout $JDCLOUD_STREAMER_ANDROID_BRANCH
git pull origin $JDCLOUD_STREAMER_ANDROID_BRANCH

echo "====================== gen sdk jar ========================"
./gradlew -q clean

./gradlew -q proguardJar
cd -

echo "====================== copy libs to demo ======================"

rm -rf app/src/main/jniLibs/*

cp -rf ${JDCLOUD_STREAMER_ANDROID_DIR}/player/build/intermediates/library_and_local_jars_jni/release/* app/src/main/jniLibs/

cp -rf ${JDCLOUD_STREAMER_ANDROID_DIR}/live/build/intermediates/library_and_local_jars_jni/release/arm64-v8a/*.so app/src/main/jniLibs/arm64-v8a
cp -rf ${JDCLOUD_STREAMER_ANDROID_DIR}/live/build/intermediates/library_and_local_jars_jni/release/armeabi-v7a/*.so app/src/main/jniLibs/armeabi-v7a
cp -rf ${JDCLOUD_STREAMER_ANDROID_DIR}/live/build/intermediates/library_and_local_jars_jni/release/x86/*.so app/src/main/jniLibs/x86

cp  ${JDCLOUD_STREAMER_ANDROID_DIR}/live/build/libs/jdcloudlive.jar app/libs/
cp  ${JDCLOUD_STREAMER_ANDROID_DIR}/player/build/libs/jdcloudplayer.jar app/libs/

echo "====================== gen apk  ========================"
./gradlew -q clean
./gradlew -q build


#rm -rf output
#mkdir output
#mkdir output/libs

#cp -rf ./app/src/main/jniLibs/* output/libs
#cp ./app/libs/jdcloudlive.jar output/libs
#cp ./app/libs/jdcloudplayer.jar output/libs

